// background.js
console.log('我是后台js...');
//
function util_check_expire(expire_date=''){
    if(expire_date==''){
        return true;
    }
    expire_date = expire_date.replace('T00:00:00.000Z','');
    let now_date = new Date();
    expire_date_list = expire_date.split('-');
    expire_date_f = new Date(expire_date_list[0], (expire_date_list[1]-1), expire_date_list[2]);
    if (now_date > expire_date_f) {
        return true;
    }
    return false;
}

function util_isnumber(val){
    var regPos = /^[0-9]+.?[0-9]*/; //判断是否是数字。
    if(regPos.test(val) ){
        return true;
    }else{
        return false;
    }
}

function plugin_set_expire(expire,callback){
    chrome.storage.local.set({expire: expire}, callback);
}

function plugin_get_expire(callback){
    chrome.storage.local.get('expire', callback);
}

function util_checkFanpa(str = ''){
    const searchString = "This item is sold out";
    const regex = new RegExp(searchString);
    const containsString = regex.test(str);
    if(containsString){
        return true;
    } else {
        return false;
    }
}

function util_getscript_pageData_content(html=''){
    // 示例HTML代码
    // 正则表达式匹配<script>标签内容的模式
    var scriptTagPattern = /<script\b[^>]*>([\s\S]*?)<\/script>/gm;
    var matches = html.match(scriptTagPattern);
    if (matches) {
        for (var i = 0; i < matches.length; i++) {
            // 提取<script>标签里的内容
            var scriptContent = matches[i].replace(scriptTagPattern, '$1');
            if(scriptContent.indexOf('QuantityViewModel') !=-1 || scriptContent.indexOf('mediaList') !=-1 ){
               return scriptContent;
            }
        }
    }
    return false;
}

function pause_s_time(){
    chrome.storage.local.get(null, function(items) {
        //
        chrome.storage.local.set({pause_s_time: Date.now()});
    });
}

function pause_switch(callback){
    chrome.storage.local.get(null, function(items) {
        //
        let prefix = 'pause';
        if (!items.hasOwnProperty(prefix)) {
            chrome.storage.local.set({pause: 1}, callback);
        }else{
            if(items[prefix] == 1){
                chrome.storage.local.set({pause: 0}, callback);
            }else{
                chrome.storage.local.set({pause: 1}, callback);
            }
        }
    });
}

function pause_page_switch(callback){
    chrome.storage.local.get(null, function(items) {
        //
        let prefix = 'pause_page';
        if (!items.hasOwnProperty(prefix)) {
            chrome.storage.local.set({pause_page: 1}, callback);
        }else{
            if(items[prefix] == 1){
                chrome.storage.local.set({pause_page: 0}, callback);
            }else{
                chrome.storage.local.set({pause_page: 1}, callback);
            }
        }
    });
}

function pause_list_switch(callback){
    chrome.storage.local.get(null, function(items) {
        //
        let prefix = 'pause_list';
        if (!items.hasOwnProperty(prefix)) {
            chrome.storage.local.set({pause_list: 1}, callback);
        }else{
            if(items[prefix] == 1){
                chrome.storage.local.set({pause_list: 0}, callback);
            }else{
                chrome.storage.local.set({pause_list: 1}, callback);
            }
        }
    });
}

function field_name_set(field_name = '', callback){
    chrome.storage.local.set({field_name: field_name}, callback);
}
// Function to convert an image to a Blob
async function imageToBlob(imageUrl) {
  try {
    // Fetch the image as an array buffer
    const response = await fetch(imageUrl);
    const arrayBuffer = await response.arrayBuffer();

    // Create a Blob from the array buffer
    const blob = new Blob([arrayBuffer], { type: response.headers.get("content-type") });

    return blob;
  } catch (error) {
    console.error("Error converting image to Blob:", error);
    return null;
  }
}

// Usage example:
/*const imageUrl = "https://img.kwcdn.com/product/Fancyalgo/VirtualModelMatting/8af63f79afdd388711b1c34289c15cda.jpg?imageView2/2/w/800/q/70/format/webp";
imageToBlob(imageUrl)
  .then(blob => {
    if (blob) {
      // Do something with the Blob, such as uploading it or displaying it
        console.log('aaaa');
        console.log(blob);
    } else {
        console.log("Failed to convert image to Blob.");
    }
  });*/

function urlToBase64(url, callback) {
  const xhr = new XMLHttpRequest();
  xhr.onload = function() {
    const reader = new FileReader();
    reader.onloadend = function() {
      callback(reader.result);
    };
    reader.readAsDataURL(xhr.response);
  };
  xhr.open('GET', url);
  xhr.responseType = 'blob';
  xhr.send();
}

function util_chartoint(str = ''){;
    let numbers = "";
    for (let i = 0; i < str.length; i++) {
        if (!isNaN(parseInt(str[i]))) {
            numbers += str[i];
        }
    }
    return parseInt(numbers);
}

function ajax_get(url){
    console.log('url:'+url);
    let _html_result = '';
    var exhibitors_ajax = $.ajax({
             //url: 'https://www.google.com/maps/place/VIP+Wigs+%26+Prosthesis/@37.9009282,-122.0623831,17z/data=!3m1!4b1!4m6!3m5!1s0x808561953bedbbfd:0xe9365860131da46b!8m2!3d37.9009282!4d-122.0623831!16s%2Fg%2F1tcxpx4r?authuser=0&hl=en',
             url:url,
             data: {},
             type: 'GET',
             async:false,
             crossDomain: true,
             //timeout:20000,//20 s
             dataType: 'html',
             contentType:'text/html; charset=utf-8',
             //dataType: 'json',
             //contentType:'application/json;charset=utf-8',
             success: function(data) {
                 _html_result = data;
             },
             error: function(xhr, textStatus, errorThrown) {
                _html_result = 'error';
            }
         });
    return _html_result;
}

// 使用示例
/*const imageUrl = 'https://example.com/image.jpg'; // 替换为你自己的图片URL
urlToBase64(imageUrl, function(base64String) {
  console.log(base64String); // 这里是Base64编码的图片字符串
});*/
//
function storage_shangjia_about_contact_and_basic_info_set(_shangjia_info={}, callback){
    let prefix = 'shangjia_about_contact_and_basic_info_'+$.md5(_shangjia_info['_shangjia_id']);
    //
    chrome.storage.local.get(null, function(items) {
        //
        if(!items.hasOwnProperty(prefix)){
            let obj = {};
            obj[prefix] = {
                '_shangjia_id': _shangjia_info['_shangjia_id'],
                //'_shangjia_name': _shangjia_info['_shangjia_name'],
                //'_shangjia_catalog_1': '',
                //'_shangjia_catalog_2': '',
                '_shangjia_about_contact_and_basic_info_link':_shangjia_info['_shangjia_a_link'],

                '_is_request':0,

                //'_shangjia_img': _shangjia_info['_shangjia_img'],
                //'_shangjia_images': '',
                //'_shangjia_img_blob': '',
                //'_shangjia_price': _shangjia_info['_shangjia_price'],
               // '_shangjia_old_price': _shangjia_info['_shangjia_old_price'],
                //'_shangjia_review_score': _shangjia_info['_shangjia_review_score'],
                //'_shangjia_reivew_num': _shangjia_info['_shangjia_reivew_num'],
                //'_shangjia_sold': _shangjia_info['_shangjia_sold'],
                //'_shangjia_desc':'',

                '_shangjia_store_name': '',
                '_shangjia_store_url': '',
                '_shangjia_store_items': '',
                '_shangjia_store_followers': '',
                '_shangjia_store_sold': '',
                '_shangjia_store_score': '',
                '_shangjia_store_created_date':'',
                //
                '_shangjia_goodsId':'', //sku
                '_shangjia_variants_skus': [], //数组
                '_shangjia_goodsName': '',
                '_shangjia_goodsProperty':'',//description,deschtml
                '_shangjia_description':'',//description,deschtml
                '_shangjia_minOnSalePriceStr':'', //最小价格,当没有属性时选择该价格
                '_shangjia_normalLinePriceStr':'', //原价
                '_shangjia_quantity':'', //库存
                '_shangjia_hdThumbUrl': '',//主图
                '_shangjia_gallery':[], //图片列表
                '_shangjia_productDetailFlatList':[],//details imgs
                '_shangjia_category':'',//brumb
                '_shangjia_VideoUrl':'', //video
                //

            };
            chrome.storage.local.set(obj, callback);
        }
        //
    });
    //
}

function request_shangjia_about_contact_and_basic_info_ajax(storage_key=''){
    chrome.storage.local.get(null, function(items) {
        let need_item = items[storage_key];
        //
        //need_item['_shangjia_about_contact_and_basic_info_link'] = 'https://www.temu.com/goods.html?_bg_fs=1&goods_id=601099513966458';
        if(need_item['_shangjia_about_contact_and_basic_info_link'] && need_item['_shangjia_about_contact_and_basic_info_link'].indexOf('goods.html') !=-1){
            need_item['_e_time'] = Date.now();
            need_item['_is_request'] = 2;
            let obj = {};
            obj[storage_key] = need_item;
            chrome.storage.local.set(obj, function (){
            });
            return;
        }
        //need_item['_shangjia_about_contact_and_basic_info_link'] = 'https://www.ebay.com/itm/296062193141';
        console.log('request_shangjia_about_contact_and_basic_info_ajax aaa');
        console.log(need_item['_shangjia_about_contact_and_basic_info_link']);
        //
        $.ajax({
            url:need_item['_shangjia_about_contact_and_basic_info_link'],
            timeout : 30000, //超时时间设置，单位毫秒
            data: {},
            type: 'GET',
            async:true,
            dataType: 'html',
            contentType:'text/html; charset=utf-8',
            crossDomain: true,
            cache: false,
            success: function(data) {
                console.log('data');
                //console.log(data);
                //return;
               let _dom = $(data);
               //
               let _mainContent = _dom.find('.mainContent').text();
               let _baseContent = _dom.find('.baseContent').text();
               let _checkContent = _mainContent;
               if(_baseContent){
                   _checkContent += _baseContent;
               }
               if(false && util_checkFanpa(_checkContent)){
                   console.log('util_checkFanpa a1');
                   //
                    need_item['_is_request'] = 0;
                    need_item['_error'] = '遇到Temu反爬,请开启或者更换代理或者暂停采集，稍后再采集!';
                    let obj = {};
                    obj[storage_key] = need_item;
                    chrome.storage.local.set(obj, function (){
                            //

                            //
                    });
                    pause_s_time();
                    sendPopTips("遇到Temu反爬,请开启或者更换代理或者暂停采集，稍后再采集!", need_item['_shangjia_about_contact_and_basic_info_link']);
                    //
               }else{
                   //console.log('util_checkFanpa a2');
                   //
                   let scriptdata = util_getscript_pageData_content(data);
                   if(scriptdata){
                       scriptdata = scriptdata.trim();
                       scriptdata = scriptdata.replace("(window.$ebay||($ebay = {})).tracking={pageId:'2332490',pageName:'vinode'};$MC=(window.$MC||[]).concat(",'')
                       scriptdata = scriptdata.slice(0,-1);
                       console.log('scriptdata_json a1');
                       let scriptdata_json = JSON.parse(scriptdata);
                       console.log(scriptdata_json);
                       if(scriptdata_json && scriptdata_json['o']['g']['itemId']){
                            /*
                            '_shangjia_store_name': '',
                            '_shangjia_store_url': '',
                            '_shangjia_store_items': '',
                            '_shangjia_store_followers': '',
                            '_shangjia_store_sold': '',
                            '_shangjia_store_score': '',
                            '_shangjia_store_review_num':'',
                            //
                            '_shangjia_sold': '',
                             _shangjia_reivew_num
                            '_shangjia_goodsId':'', //sku
                            '_shangjia_variants_skus': [], //数组
                            '_shangjia_goodsName': '',
                            '_shangjia_goodsProperty':'',//description,deschtml
                            '_shangjia_minOnSalePriceStr':'', //最小价格,当没有属性时选择该价格
                            '_shangjia_gallery':[], //图片列表
                            '_shangjia_productDetailFlatList':[],//details imgs
                            '_shangjia_category':'',//brumb
                            '_shangjia_VideoUrl':'', //video
                             */
                           //
                           let _goods_data = {};
                           let model_pre = scriptdata_json['o']['w'][0][2];
                           if(model_pre.hasOwnProperty('model')){
                               _goods_data = scriptdata_json['o']['w'][0][2]['model']['modules'];
                           }else{
                               _goods_data = scriptdata_json['o']['w'][1][2]['model']['modules'];
                           }
                           if(true){
                               let _shangjia_goodsId = scriptdata_json['o']['g']['itemId'];
                               need_item['_shangjia_goodsId'] = _shangjia_goodsId;

                               let _shangjia_goodsName = _goods_data['JSONLD']['product']['name'];
                               need_item['_shangjia_goodsName'] = _shangjia_goodsName;

                               need_item['_shangjia_hdThumbUrl'] = _goods_data['JSONLD']['product']['image'];

                               let _shangjia_minOnSalePriceStr = _goods_data['BUY_BOX']['binModel']['price']['value']['convertedFromValue'];
                               need_item['_shangjia_minOnSalePriceStr'] = _shangjia_minOnSalePriceStr;

                               let _shangjia_normalLinePriceStr = _goods_data['BUY_BOX']['binModel']['priceApprox']['value']['value'];
                               need_item['_shangjia_normalLinePriceStr'] = _shangjia_normalLinePriceStr;

                               let _shangjia_quantity = _goods_data['QUANTITY']['availabilitySignal']['textSpans'][0]['text'];
                               _shangjia_quantity = util_chartoint(_shangjia_quantity)
                               need_item['_shangjia_quantity'] = _shangjia_quantity;

                               let _shangjia_gallery = [];
                               let _shangjia_VideoUrl = '';
                               let _shangjia_gallery_list = _goods_data['PICTURE']['mediaList'];
                               for(let _i = 0;_i < _shangjia_gallery_list.length; _i++){
                                   _shangjia_gallery.push(_shangjia_gallery_list[_i]['image']['originalImg']['URL'])
                               }
                               need_item['_shangjia_gallery'] = _shangjia_gallery;
                               need_item['_shangjia_VideoUrl'] = _shangjia_VideoUrl;
                               let _shangjia_goodsProperty = _dom.find('.x-about-this-item').html();
                               _shangjia_goodsProperty = "<div id='viTabs_0_is' class='vim x-about-this-item'>"+_shangjia_goodsProperty+"</div>";
                               need_item['_shangjia_goodsProperty'] = _shangjia_goodsProperty;
                               //
                               let _desc_url = _goods_data['ITEM_DESCRIPTION_MIN_VIEW_MODULE']['sections'][0]['action']['URL'];
                               if(_desc_url){
                                  let _description_html = ajax_get(_desc_url);
                                  let _description_dom = $(_description_html);
                                  let _description = _description_dom.find(".x-item-description-child").html();
                                  need_item['_shangjia_description']="<div class='vim d-item-description'>"+_description+"</div>";
                               }
                               //
                               /*let _shangjia_productDetailFlatList = [];
                               let _shangjia_productDetailFlatList_Data = scriptdata_json['store']['productDetailFlatList'];
                               if(_shangjia_productDetailFlatList_Data){
                                   for(_j=0;_j<_shangjia_productDetailFlatList_Data.length;_j++){
                                        _shangjia_productDetailFlatList.push(_shangjia_productDetailFlatList_Data[_j]['url']);
                                   }
                               }*/
                               need_item['_shangjia_productDetailFlatList'] = [];
                               //
                               let _shangjia_category = '';
                               _dom.find("nav.breadcrumbs li").each(function (){
                                   let _nav_text = $(this).find('span').text();
                                   _shangjia_category+=_nav_text+' > ';
                               });
                               if(_shangjia_category.length>0){
                                   _shangjia_category = _shangjia_category.trim();
                                   _shangjia_category = _shangjia_category.slice(0,-1);
                               }
                               need_item['_shangjia_category'] = _shangjia_category;
                               //
                               let _shangjia_variants_skus = [];
                               let msku = _goods_data['MSKU'];
                               let _shangjia_sold = 0;
                               if(msku){
                                   let variationCombinations = msku['variationCombinations'];//子sku
                                   let selectMenus = msku['selectMenus'];//属性名
                                   let menuItemMap = msku['menuItemMap']; //属性值
                                   let variationsMap = msku['variationsMap'];//变体对应的价格、库存
                                   for(let vc_key in variationCombinations){
                                       //
                                       let specs_key1_name = '';
                                       let specs_key1_value = '';
                                       let specs_key2_name = '';
                                       let specs_key2_value = '';
                                       let specs_key3_name = '';
                                       let specs_key3_value = '';
                                       let specs_key4_name = '';
                                       let specs_key4_value = '';
                                       //
                                       let attr_arr = vc_key.split('_');
                                       for(let attr_i in attr_arr){
                                           //通过属性值id找属性值
                                           let attr_id_val = parseInt(attr_arr[attr_i]); //属性值id
                                           let attr_val = '';
                                           //
                                           for(let attr_val_i in menuItemMap){
                                               if(menuItemMap[attr_val_i]['valueId'] == attr_id_val){
                                                   attr_val = menuItemMap[attr_val_i]['displayName'];
                                                   break;
                                               }
                                           }
                                           //通过属性值id找属性名
                                           let attr_name = '';
                                           for(let attr_name_i in selectMenus){
                                                let menuItemValueIds = selectMenus[attr_name_i]['menuItemValueIds'];
                                                if(menuItemValueIds.indexOf(attr_id_val) !== -1){
                                                    attr_name = selectMenus[attr_name_i]['displayLabel'];
                                                    break;
                                                }
                                           }
                                           //
                                           if(attr_i ==0){
                                               specs_key1_name = attr_name;
                                               specs_key1_value = attr_val;
                                           }else if(attr_i ==1){
                                               specs_key2_name = attr_name;
                                               specs_key2_value = attr_val;
                                           }else if(attr_i ==2){
                                               specs_key3_name = attr_name;
                                               specs_key3_value = attr_val;
                                           }else if(attr_i ==3){
                                               specs_key4_name = attr_name;
                                               specs_key4_value = attr_val;
                                           }
                                           //
                                       }
                                       //
                                       let subsku_specs = _shangjia_goodsId+specs_key1_value+specs_key2_value+specs_key3_value+specs_key4_value; //自定义子sku
                                       subsku_specs = subsku_specs.replaceAll(' ','');
                                       //
                                       let ziskuId = variationCombinations[vc_key];
                                       let variationPriceQtyData = variationsMap[ziskuId];
                                       let normalPriceStr = variationPriceQtyData['binModel']['price']['value']['convertedFromValue'];
                                       //
                                       let normalLinePriceStr = '';
                                       if(variationPriceQtyData['binModel'].hasOwnProperty('additionalInfo')){
                                           let normalLinePriceStrSpans =  variationPriceQtyData['binModel']['additionalInfo'][0]['additionalText']['textSpans'];
                                           if(normalLinePriceStrSpans.length >=3){
                                               normalLinePriceStr = normalLinePriceStrSpans[1]['text'];
                                               if(normalLinePriceStr){
                                                   normalLinePriceStr = normalLinePriceStr.replace('US $','');
                                                   normalLinePriceStr = normalLinePriceStr.trim();
                                               }
                                           }
                                       }
                                       //
                                       let stockQuantity = '';
                                       let quantity_validations = variationPriceQtyData['quantity']['quantityInput']['validations'];
                                       if(quantity_validations){
                                            stockQuantity = quantity_validations[0]['maxValue'];
                                       }
                                       //
                                       _shangjia_variants_skus.push({
                                            'subsku': subsku_specs,
                                            'normalPriceStr': normalPriceStr,
                                            'normalLinePriceStr': normalLinePriceStr,
                                            'img': '',
                                            'specs_key1_name':specs_key1_name,
                                            'specs_key1_value':specs_key1_value,
                                            'specs_key2_name':specs_key2_name,
                                            'specs_key2_value':specs_key2_value,
                                            'specs_key3_name':specs_key3_name,
                                            'specs_key3_value':specs_key3_value,
                                            'specs_key4_name':specs_key4_name,
                                            'specs_key4_value':specs_key4_value,
                                            'stockQuantity': stockQuantity,
                                            'skuId': ziskuId
                                       });
                                       //
                                       let quantityAvaitextSpansArr = variationPriceQtyData['quantity']['availabilitySignal']['textSpans'];
                                       if(quantityAvaitextSpansArr.length >=3){
                                            let _zisku_sold = variationPriceQtyData['quantity']['availabilitySignal']['textSpans'][2]['text'];
                                            _shangjia_sold += util_chartoint(_zisku_sold);
                                             //
                                       }
                                   }
                               }
                               need_item['_shangjia_variants_skus'] = _shangjia_variants_skus;
                               //'_shangjia_review_score': '',
                               //'_shangjia_reivew_num':'',

                               need_item['_shangjia_sold'] = _shangjia_sold;
                               //
                               let store_information = _goods_data['STORE_INFORMATION'];
                               let store_information_dataItems = store_information['sections'][0]['dataItems'];
                               let _shangjia_store_sold = '';
                               if(store_information_dataItems.length >=2){
                                   _shangjia_store_sold = store_information['sections'][0]['dataItems'][1]['textSpans'][1]['text'];
                               }
                               need_item['_shangjia_reivew_num'] = '';
                               need_item['_shangjia_store_review_num'] = '';
                               //store
                               /**
                                * '_shangjia_store_name': '',
                                '_shangjia_store_url': '',
                                '_shangjia_store_items': '',
                                '_shangjia_store_followers': '',
                                '_shangjia_store_sold': '',
                                '_shangjia_store_score': '',
                                */
                               let _shangjia_store_followers = 0;

                               need_item['_shangjia_store_name'] = store_information['title']['action']['clientPresentationMetadata']['_ssn'];
                               need_item['_shangjia_store_url'] = store_information['title']['action']['URL'];
                               need_item['_shangjia_store_items'] = '';
                               need_item['_shangjia_store_followers'] = '';
                               need_item['_shangjia_store_sold'] = _shangjia_store_sold;
                               need_item['_shangjia_store_score'] ='';
                               need_item['_shangjia_store_created_date'] = store_information['sections'][1]['dataItems'][0]['text']['textSpans'][0]['text'];
                               //
                               need_item['_is_request'] = 2;
                           }else if(_goods_data['status'] == 5 && !_goods_data.hasOwnProperty('goodsName')){ //反爬
                               console.log('scriptdata_json This item is sold out.反爬');
                                need_item['_is_request'] = 0;
                                need_item['_error'] = '';
                                pause_s_time();
                                sendPopTips("遇到Temu反爬,请开启或者更换代理或者暂停采集，稍后再采集!", need_item['_shangjia_about_contact_and_basic_info_link']);
                                //
                           }else{
                               if(!_goods_data.hasOwnProperty('status')){
                                   need_item['_is_request'] = 0;
                                   need_item['_error'] = '';
                                   pause_s_time();
                                   sendPopTips("请检查网络，无法正常访问商品详情页！", need_item['_shangjia_about_contact_and_basic_info_link']);
                                    //
                               }else{
                                   //其它类型的比如购买完了，下架了等
                                   console.log('scriptdata_json 其它类型的比如购买完了，下架了等');
                                   need_item['_is_request'] = 2;
                               }
                           }
                       }else{
                           console.log('scriptdata_json 未发现goods id');
                           need_item['_is_request'] = 0;
                           need_item['_error'] = '';
                           pause_s_time();
                           sendPopTips("遇到Temu反爬,请开启或者更换代理或者暂停采集，稍后再采集!", need_item['_shangjia_about_contact_and_basic_info_link']);
                            //
                       }
                       //
                   }else{
                       console.log('scriptdata_json error');
                       need_item['_is_request'] = 0;
                       need_item['_error'] = '';
                       pause_s_time();
                       sendPopTips("遇到Temu反爬,请开启或者更换代理或者暂停采集，稍后再采集!", need_item['_shangjia_about_contact_and_basic_info_link']);
                        //
                   }
                   //
                   need_item['_e_time'] = Date.now();
                   console.log('need_item');
                   console.log(need_item);
                   let obj = {};
                   obj[storage_key] = need_item;
                   chrome.storage.local.set(obj, function (){
                   });
                   //
                   /*if(need_item['_shangjia_img']){
                       urlToBase64(need_item['_shangjia_img'], function(base64String) {
                           //console.log(blob);
                            //need_item['_shangjia_img_blob'] = base64String;
                            //
                            need_item['_is_request'] = 2;
                            need_item['_e_time'] = Date.now();
                            let obj = {};
                            obj[storage_key] = need_item;
                            chrome.storage.local.set(obj, function (){
                            });
                            //
                        });
                   }*/
                   //
               }
            },
            error: function( jqXHR, textStatus, errorThrown ) {
                console.log('ajax error');
                console.log( jqXHR, textStatus, errorThrown );
                //
                need_item['_is_request'] = 0;
                need_item['_error'] = errorThrown;
                let obj = {};
                obj[storage_key] = need_item;
                chrome.storage.local.set(obj, function (){
                        //

                        //
                });
                //
                pause_s_time();
                sendPopTips("遇到Temu反爬,请开启或者更换代理或者暂停采集，稍后再采集!", need_item['_shangjia_about_contact_and_basic_info_link']);
                    //
            }
        });
        //
    })
}

function request_shangjia_about_contact_and_basic_info(){
    chrome.storage.local.get(null, function(items) {
        //
        let binfa = 0;
        for(let key in items){
             if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                 if(items[key]['_is_request'] == 1){
                     binfa++;
                     if(binfa == 5){
                         break;
                     }
                 }
             }
        }
        if(binfa < 5 || true){
          let need_item = null;
          for(let key in items){
                if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                    if(items[key]['_is_request'] == 0 || (items[key]['_is_request'] == 1 && items[key]['_s_time'] < (Date.now()-10000))){
                        need_item = items[key];
                        need_item['_is_request'] = 1;
                        need_item['_s_time'] = Date.now();
                        let obj = {};
                        obj[key] = need_item;
                        chrome.storage.local.set(obj, function (){
                            //
                            request_shangjia_about_contact_and_basic_info_ajax(key);
                            //
                        });
                        break;
                    }
                }
          }
        }
        //
    });
}

function xintiao(){
     chrome.storage.local.get(null, function(items) {
         if(!items.hasOwnProperty('pause') || items['pause'] == 0){
             //360000
             if(items.hasOwnProperty('pause_s_time')  && (items['pause_s_time']+60000) > Date.now()){
                console.log('爬取失败，暂停60s');
             }else{
                 console.log('爬取中');
                 request_shangjia_about_contact_and_basic_info();
             }
         }else{
             console.log('已暂停爬取');
         }
    });

    //request_shangjia_about_work_and_education_link();
    //request_shangjia_company_page_link();
    chrome.storage.local.get(null, function(items) {
        console.log('items');
        console.log(items);
    });
    //let str = '';

    //let _dom = $(str);
    //https://www.facebook.com/gabriella.obi.77/about_work_and_education
    //
    //let _shangjia_company_page_link = _dom.find('.x1gan7if span.xvq8zen a.x1a2a7pz.xt0b8zv').attr('href');
    //console.log(_shangjia_company_page_link);

    //let _shangjia_company_page_name = _dom.find('.x1gan7if span.xvq8zen a.x1a2a7pz.xt0b8zv').text();
    //console.log(_shangjia_company_page_name);
}
xintiao();
setInterval(xintiao, 40000);

function storage_clear(){
    /*plugin_get_expire(function (callback_data){
        let expire_date = callback_data['expire'];
        if(typeof expire_date != 'undefined'){
            chrome.storage.local.clear(function(){
                console.log('remove all');
                plugin_set_expire(expire_date);
            })
        }else{
            chrome.storage.local.clear(function(){
                console.log('remove all');
            })
        }
    });*/
    chrome.storage.local.get(null, function(items) {
        //
        let need_item = null;
        for (let key in items) {
            if (key.indexOf('shangjia_about_contact_and_basic_info_') != -1) {
                // 清空特定值
                chrome.storage.local.remove(key, function() {
                   console.log(`键名 ${key} 的值已被清空！`);
                });
            }
            if (key.indexOf('shangjia_about_work_and_education_') != -1) {
                // 清空特定值
                chrome.storage.local.remove(key, function() {
                   console.log(`键名 ${key} 的值已被清空！`);
                });
            }
            if(key == 'shangjias'){
                // 清空特定值
                chrome.storage.local.remove(key, function() {
                   console.log(`键名 ${key} 的值已被清空！`);
                });
            }
        }
    });
}
//
function get_data_process(){

    let total_add_shangjia_num = 0;
    let has_caiji_geren_num = 0;
    let has_caiji_company_num = 0;

    chrome.storage.local.get(null, function(items) {
        //
        for(let key in items){
            if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                total_add_shangjia_num += 1;
                if(items[key]['_is_request'] == 2){
                    has_caiji_geren_num += 1;
                }
            }

        }
        //
        let obj = {};
        obj['data_process'] = {
            'total_add_shangjia_num': total_add_shangjia_num,
            'has_caiji_geren_num': has_caiji_geren_num,
            'has_caiji_company_num': has_caiji_company_num,
        }
        chrome.storage.local.set(obj, function (){
            //
            //
        });
        //
    });
}
//
function data_process_get(callback){
     /*chrome.storage.sync.get('domains', (res) => {
        console.log(res);
        return res;
     });*/
    chrome.storage.local.get('data_process', callback);
}

function storage_shangjias_update(shangjia_infos=[]){
    //console.log('storage_shangjias_update a');
    chrome.storage.local.get('shangjias', function(items) {
        //console.log('storage_shangjias_update b');
        //console.log(items);
        if(!items.hasOwnProperty('shangjias')){
            let obj = {};
            let shangjias = [];
            for(let i=0;i<shangjia_infos.length;i++){
                shangjias.push(shangjia_infos[i]['_shangjia_id']);
            }
            obj['shangjias'] = shangjias;
            chrome.storage.local.set(obj);
        }else{
            let storage_shangjias = items['shangjias'];

            for(let i=0;i<shangjia_infos.length;i++){
                let is_exists = false;
                for(let j=0;j<storage_shangjias.length;j++){
                    if(shangjia_infos[i]['_shangjia_id'] == storage_shangjias[j]){
                        is_exists = true;
                        break;
                    }
                }
                //
                if(!is_exists){
                    storage_shangjias.push(shangjia_infos[i]['_shangjia_id']);
                }
                //
            }
            //
            let obj = {};
            obj['shangjias'] = storage_shangjias;
            chrome.storage.local.set(obj);
            //
        }
    })
}

function storage_get(callback){
    chrome.storage.local.get(null, callback);
}

//监听扩展程序进程或内容脚本发送请求的请求
chrome.runtime.onMessage.addListener(
  function (request, sender, sendResponse) {
    if (request.action == 'shangjia_items_update') {
        console.log('action',request,sender,sendResponse);
        //
        let shangjia_infos = request.shangjia_infos;
        //
        //storage_shangjias_update(shangjia_infos);
        //
        for (let i=0;i<shangjia_infos.length;i++){
            storage_shangjia_about_contact_and_basic_info_set(shangjia_infos[i],function (){

            });
        }
        //
        //request {action: "send", keyword: "keyword value"}
        //sender  {id: "agkllkkjbhclhjnlebdbdagkagfgcecj", url: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj/popup.html", origin: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj"}
        //sendResponse  ƒ () { [native code] }
        sendResponse({state:'关键词填写成功！'});
    }else if(request.action  == 'can_zidong_caiji'){
        console.log('can_zidong_caiji',request,sender,sendResponse);
        //判断，如果加入超过5000个，则不能，而且需要已开启自动采集
        chrome.storage.local.get(null, function(items) {
            if(!items.hasOwnProperty('pause_page') || items['pause_page'] == 0){
                //已开启
                let total_add_shangjia_num = 0;
                for(let key in items){
                    if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                        total_add_shangjia_num += 1;
                    }
                }
                if(total_add_shangjia_num < 5000){
                    sendResponse(JSON.stringify({state:0}));
                }else{
                    sendResponse(JSON.stringify({state:1}));
                }
                //
            }else{
                //已关闭
                sendResponse(JSON.stringify({state:1}));
            }
        });
        //
        return true;
    }else if(request.action  == 'can_list_caiji'){
        console.log('can_list_caiji',request,sender,sendResponse);
        //判断，如果加入超过5000个，则不能，而且需要已开启自动采集
        chrome.storage.local.get(null, function(items) {
            if(!items.hasOwnProperty('pause_list') || items['pause_list'] == 0){
                //已开启
                let total_add_shangjia_num = 0;
                for(let key in items){
                    if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                        total_add_shangjia_num += 1;
                    }
                }
                if(total_add_shangjia_num < 5000){
                    sendResponse(JSON.stringify({state:0}));
                }else{
                    sendResponse(JSON.stringify({state:1}));
                }
                //
            }else{
                //已关闭
                sendResponse(JSON.stringify({state:1}));
            }
        });
        //
        return true;
    }else if(request.action  == 'get_description'){
         let url = request.url;
         let description_data = ajax_get(url);
         sendResponse(JSON.stringify({description:description_data}));
         return true;
    }else if(request.action == 'check_expire'){
        //
        chrome.storage.local.get(null, function(items) {
            //
            let prefix = 'expire';
            if (!items.hasOwnProperty(prefix)) {
               //
                sendResponse(JSON.stringify({state:1}));
                //
            }else{
                let expire_date = items['expire'];
                console.log('expire_date');
                console.log(expire_date);
                expire_date = expire_date.replace('T00:00:00.000Z','');
                if (util_check_expire(expire_date)) {
                    sendResponse(JSON.stringify({state:1}));
                }else{
                    sendResponse(JSON.stringify({state:0}));
                }
            }
        })
        return true;
        //
    }
  }
);

/**
 * 1.
 * chrome.runtime.onInstalled.addListener(details => {
  console.log('previousVersion', details.previousVersion);
});
2.
 //发送消息
 chrome.runtime.sendMessage({
        action: 'send',
        keyword: 'keyword value'
      }, function (response) {   //接收回调
        console.log(response);  //{state:'关键词填写成功！'}
      });

//监听扩展程序进程或内容脚本发送请求的请求
chrome.runtime.onMessage.addListener(
  function (request, sender, sendResponse) {
    if (request.action == 'send') {
      console.log('action',request,sender,sendResponse);
//  request {action: "send", keyword: "keyword value"}
 //sender  {id: "agkllkkjbhclhjnlebdbdagkagfgcecj", url: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj/popup.html", origin: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj"}
//sendResponse  ƒ () { [native code] }
      sendResponse({state:'关键词填写成功！'});
    }
  }
);
 */

function sendPopTips(msg = '', url=''){
    //
    if(url){
        console.log('sendPopTips url:'+url);
        chrome.tabs.create({url: url}, function(newTab) {
            // 监听标签页的更新事件
            chrome.tabs.onUpdated.addListener(function(tabId, changeInfo, tab) {
              // 检查页面是否已完全加载
              if (tabId === newTab.id && changeInfo.status === "complete") {
                // 在这里执行你想要在页面加载完成后执行的操作
                console.log("页面已完全加载");
                //sendResponse(JSON.stringify({}));
                // 你可以继续在这里添加其他代码
              }
            });
          });
    }
    //
     chrome.runtime.sendMessage({
        action: 'background-tips',
        info: msg,
         url:url,
      }, function (response) {   //接收回调
        console.log(response);  //{state:'关键词填写成功！'}
      });
}