function util_check_expire(expire_date=''){
    if(expire_date==''){
        return true;
    }
    expire_date = expire_date.replace('T00:00:00.000Z','');
    let now_date = new Date();
    expire_date_list = expire_date.split('-');
    expire_date_f = new Date(expire_date_list[0], (expire_date_list[1]-1), expire_date_list[2]);
    if (now_date > expire_date_f) {
        return true;
    }
    return false;
}

function util_check_is_maps_page(){
     //检测当前是否maps页面
    chrome.tabs.getSelected(null, function (tab) {
        var current_url =  tab.url;
        if(current_url){
            if(current_url.indexOf('ebay')==-1){
                   chrome.tabs.create({ url: "https://www.ebay.com/" });
            }
        }else{
            chrome.tabs.create({ url: "https://www.ebay.com/" });
        }
    });
}

function util_get_date(){
    // 创建一个Date对象来获取当前日期
    let currentDate = new Date();
    // 获取年、月、日
    let year = currentDate.getFullYear();
    let month = (currentDate.getMonth() + 1).toString().padStart(2, '0'); // 月份从0开始，所以需要加1，并确保两位数
    let day = currentDate.getDate().toString().padStart(2, '0'); // 日期，确保两位数
    // 格式化为年月日
    let formattedDate = year + '-' + month + '-' + day;
    return formattedDate;
}

function get_expire(){
    var bg = chrome.extension.getBackgroundPage();
    bg.plugin_get_expire(function (callback_data){
        let expire_date = callback_data['expire'];
        if(typeof expire_date === 'undefined'){
            $('.jihuo').show();
            $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
            $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin?plugin=vip_ebay_1nian&type=other_plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
            return;
        }else{
            console.log('expire_date');
            console.log(expire_date);
            expire_date = expire_date.replace('T00:00:00.000Z','');
            $('#expire_date').html(expire_date);
            if (util_check_expire(expire_date)) {
                $('.jihuo').show();
                $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin?plugin=vip_ebay_1nian&type=other_plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                return;
            }
        }
    });
}

get_expire();

function extract_catalog_products_export_url(){
    $('#extract-catalog-products-export-url').click(function (){
         //
        $('#message-info').html('<span style="font-size: 12px;">提取需要花费时间，请保持界面不动,处理中...</span>')
        console.log('extract-catalog-products-url');
        //
        var bg = chrome.extension.getBackgroundPage();
        bg.storage_get(function (callback_data) {
            console.log('extract_catalog_products_export_clean');
            console.log(callback_data);
            //
            let expire_date = callback_data['expire'];
            if(typeof expire_date === 'undefined'){
                $('.jihuo').show();
                $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin?plugin=vip_ebay_1nian&type=other_plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                return;
            }else{
                console.log('expire_date');
                console.log(expire_date);
                expire_date = expire_date.replace('T00:00:00.000Z','');
                $('#expire_date').html(expire_date);
                if (util_check_expire(expire_date)) {
                    $('.jihuo').show();
                    $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                    $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin?plugin=vip_ebay_1nian&type=other_plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                    return;
                }
            }
            //通用导出
            chrome.storage.local.get(null, function(items) {
                let export_datas = [];
                //
                for (let key in items) {
                    if (key.indexOf('shangjia_about_contact_and_basic_info_') != -1) {
                       let shangjia_about_contact_and_basic_info = items[key];
                       let export_data_item = {
                           '商品url': shangjia_about_contact_and_basic_info['_shangjia_about_contact_and_basic_info_link'],
                       }
                       export_datas.push(export_data_item);
                       //
                    }
                }
                //
                exportToExcel(export_datas, 'gycharm-ebay-export-products-url-'+Date.now(), "Sheet1");
                //
            });
            //
            $('#message-info').html('');
            //
        });
        //
    });
}

extract_catalog_products_export_url();

function extract_catalog_products_export_clean(){
    $('#extract-catalog-products-export-clean').click(function (){
        util_check_is_maps_page();
        //
         //
        $('#message-info').html('<span style="font-size: 12px;">提取需要花费时间，请保持界面不动,处理中...</span>')
        console.log('extract-catalog-products-url');
        //
        var bg = chrome.extension.getBackgroundPage();
        bg.storage_get(function (callback_data) {
            console.log('extract_catalog_products_export_clean');
            console.log(callback_data);
            //
            let expire_date = callback_data['expire'];
            if(typeof expire_date === 'undefined'){
                $('.jihuo').show();
                $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin?plugin=vip_ebay_1nian&type=other_plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                return;
            }else{
                console.log('expire_date');
                console.log(expire_date);
                expire_date = expire_date.replace('T00:00:00.000Z','');
                $('#expire_date').html(expire_date);
                if (util_check_expire(expire_date)) {
                    $('.jihuo').show();
                    $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                    $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin?plugin=vip_ebay_1nian&type=other_plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                    return;
                }
            }
            //通用导出
            chrome.storage.local.get(null, function(items) {
                let export_datas = [];
                //
                for (let key in items) {
                    if (key.indexOf('shangjia_about_contact_and_basic_info_') != -1) {
                        if (items[key]['_is_request'] == 2) {
                            let shangjia_about_contact_and_basic_info = items[key];
                            let _shangjia_goodsId = shangjia_about_contact_and_basic_info['_shangjia_goodsId']
                            if(_shangjia_goodsId == ''){
                                continue;
                            }
                            //
                            let _shangjia_variants_skus = shangjia_about_contact_and_basic_info['_shangjia_variants_skus'];
                            //
                            let _shangjia_gallery_arr = shangjia_about_contact_and_basic_info['_shangjia_gallery'];

                            let futu1 = '';
                            let futu2 = '';
                            let futu3 = '';
                            let futu4 = '';
                            let futu5 = '';

                            let futu6 = '';
                            let futu7 = '';
                            let futu8 = '';
                            let futu9 = '';
                            let futu10 = '';

                            let futu11 = '';
                            let futu12 = '';
                            let futu13 = '';
                            let futu14 = '';
                            let futu15 = '';

                            let futu16 = '';
                            let futu17 = '';
                            let futu18 = '';
                            let futu19 = '';
                            let futu20 = '';

                            if(_shangjia_gallery_arr.length>=1){
                                futu1 = _shangjia_gallery_arr[0];
                            }
                            if(_shangjia_gallery_arr.length>=2){
                                futu2 = _shangjia_gallery_arr[1];
                            }
                            if(_shangjia_gallery_arr.length>=3){
                                futu3 = _shangjia_gallery_arr[2];
                            }
                            if(_shangjia_gallery_arr.length>=4){
                                futu4 = _shangjia_gallery_arr[3];
                            }
                            if(_shangjia_gallery_arr.length>=5){
                                futu5 = _shangjia_gallery_arr[4];
                            }
                            if(_shangjia_gallery_arr.length>=6){
                                futu6 = _shangjia_gallery_arr[5];
                            }
                            if(_shangjia_gallery_arr.length>=7){
                                futu7 = _shangjia_gallery_arr[6];
                            }
                            if(_shangjia_gallery_arr.length>=8){
                                futu8 = _shangjia_gallery_arr[7];
                            }
                            if(_shangjia_gallery_arr.length>=9){
                                futu9 = _shangjia_gallery_arr[8];
                            }
                            if(_shangjia_gallery_arr.length>=10){
                                futu10 = _shangjia_gallery_arr[9];
                            }
                            if(_shangjia_gallery_arr.length>=11){
                                futu11 = _shangjia_gallery_arr[10];
                            }
                            if(_shangjia_gallery_arr.length>=12){
                                futu12 = _shangjia_gallery_arr[11];
                            }
                            if(_shangjia_gallery_arr.length>=13){
                                futu13 = _shangjia_gallery_arr[12];
                            }
                            if(_shangjia_gallery_arr.length>=14){
                                futu14 = _shangjia_gallery_arr[13];
                            }
                            if(_shangjia_gallery_arr.length>=15){
                                futu15 = _shangjia_gallery_arr[14];
                            }
                            if(_shangjia_gallery_arr.length>=16){
                                futu16 = _shangjia_gallery_arr[15];
                            }
                            if(_shangjia_gallery_arr.length>=17){
                                futu17 = _shangjia_gallery_arr[16];
                            }
                            if(_shangjia_gallery_arr.length>=18){
                                futu18 = _shangjia_gallery_arr[17];
                            }
                            if(_shangjia_gallery_arr.length>=19){
                                futu19 = _shangjia_gallery_arr[18];
                            }
                            if(_shangjia_gallery_arr.length>=20){
                                futu20 = _shangjia_gallery_arr[19];
                            }
                            //
                            let _shangjia_sold = shangjia_about_contact_and_basic_info['_shangjia_sold'];
                            //
                            let _shangjia_store_items = shangjia_about_contact_and_basic_info['_shangjia_store_items'];
                            if(_shangjia_store_items){
                                _shangjia_store_items = _shangjia_store_items.replace('Items','');
                                _shangjia_store_items = _shangjia_store_items.trim();
                            }
                            //
                            //
                            let _body_html = shangjia_about_contact_and_basic_info['_shangjia_goodsProperty'];
                            /*
                            let _shangjia_productDetailFlatList = shangjia_about_contact_and_basic_info['_shangjia_productDetailFlatList'];
                            let _shangjia_productDetailFlatList_html = '<div class="_23UQG0mN">';
                            for(_f=0;_f<_shangjia_productDetailFlatList.length;_f++){
                                _shangjia_productDetailFlatList_html += "<div style='margin-bottom:5px'><img src='"+_shangjia_productDetailFlatList[_f]+"' /></div>";
                            }
                            _shangjia_productDetailFlatList_html +='</div>';
                            _body_html += "<br />"+_shangjia_productDetailFlatList_html;*/
                            //
                            //
                            let _shangjia_description = shangjia_about_contact_and_basic_info['_shangjia_description'];
                            if(_shangjia_description.length > 32767){
                                _shangjia_description = '';
                            }
                            if(_shangjia_variants_skus.length > 0){
                                for(let i=0;i<_shangjia_variants_skus.length;i++){
                                    //
                                    let specs_key1_name = _shangjia_variants_skus[i]['specs_key1_name'];
                                    let specs_key2_name = _shangjia_variants_skus[i]['specs_key2_name'];
                                    let specs_key3_name = _shangjia_variants_skus[i]['specs_key3_name'];
                                    let specs_key4_name = _shangjia_variants_skus[i]['specs_key4_name'];
                                    //
                                    let export_data_item = {
                                        '产品url': shangjia_about_contact_and_basic_info['_shangjia_about_contact_and_basic_info_link'],
                                        'SKU': 'S'+shangjia_about_contact_and_basic_info['_shangjia_goodsId'],
                                        '原变体SKU': 'S'+_shangjia_variants_skus[i]['skuId'],
                                        '变体带属性SKU': _shangjia_variants_skus[i]['subsku'],
                                        '产品标题': shangjia_about_contact_and_basic_info['_shangjia_goodsName'],
                                        'Category': shangjia_about_contact_and_basic_info['_shangjia_category'],
                                        '变体图片': _shangjia_variants_skus[i]['img'],
                                        '价格': _shangjia_variants_skus[i]['normalPriceStr'],
                                        '原价': _shangjia_variants_skus[i]['normalLinePriceStr'],
                                        '变体库存': _shangjia_variants_skus[i]['stockQuantity'],
                                        '属性1名': specs_key1_name,
                                        '属性1值': _shangjia_variants_skus[i]['specs_key1_value'],
                                        '属性2名': specs_key2_name,
                                        '属性2值': _shangjia_variants_skus[i]['specs_key2_value'],
                                        '属性3名': specs_key3_name,
                                        '属性3值': _shangjia_variants_skus[i]['specs_key3_value'],
                                        '属性4名': specs_key4_name,
                                        '属性4值': _shangjia_variants_skus[i]['specs_key4_value'],
                                        '主图': shangjia_about_contact_and_basic_info['_shangjia_hdThumbUrl'],
                                        '附图1': futu1,
                                        '附图2': futu2,
                                        '附图3': futu3,
                                        '附图4': futu4,
                                        '附图5': futu5,
                                        '附图6': futu6,
                                        '附图7': futu7,
                                        '附图8': futu8,
                                        '附图9': futu9,
                                        '附图10': futu10,
                                        '附图11': futu11,
                                        '附图12': futu12,
                                        '附图13': futu13,
                                        '附图14': futu14,
                                        '附图15': futu15,
                                        '附图16': futu16,
                                        '附图17': futu17,
                                        '附图18': futu18,
                                        '附图19': futu19,
                                        '附图20': futu20,
                                        'VideoUrl': shangjia_about_contact_and_basic_info['_shangjia_VideoUrl'],
                                        '物品详情':i==0?_body_html:'',
                                        '卖家提供的物品描述':i==0?_shangjia_description:'',
                                        //review
                                        //'review': shangjia_about_contact_and_basic_info['_shangjia_reivew_num'],
                                        'sold': _shangjia_sold,
                                        //store
                                        'store name': shangjia_about_contact_and_basic_info['_shangjia_store_name'],
                                        'store url': shangjia_about_contact_and_basic_info['_shangjia_store_url'],
                                        'store sold': shangjia_about_contact_and_basic_info['_shangjia_store_sold'],
                                        //'store review': shangjia_about_contact_and_basic_info['_shangjia_store_review_num'],
                                        //'store score': shangjia_about_contact_and_basic_info['_shangjia_store_score'],
                                        //'store followers': shangjia_about_contact_and_basic_info['_shangjia_store_followers'],
                                        //'store items': _shangjia_store_items
                                        //
                                        //'is request': shangjia_about_contact_and_basic_info['_is_request'] == 2 ? '已完成':'未',
                                    }
                                    export_datas.push(export_data_item);
                                    //
                                }
                            }else{
                                //
                                let export_data_item = {
                                    '产品url': shangjia_about_contact_and_basic_info['_shangjia_about_contact_and_basic_info_link'],
                                    'SKU': 'S'+shangjia_about_contact_and_basic_info['_shangjia_goodsId'],
                                    '原变体SKU': '',
                                    '变体带属性SKU': '',
                                    '产品标题': shangjia_about_contact_and_basic_info['_shangjia_goodsName'],
                                    'Category': shangjia_about_contact_and_basic_info['_shangjia_category'],
                                    '变体图片': '',
                                    '价格': shangjia_about_contact_and_basic_info['_shangjia_minOnSalePriceStr'],
                                    '原价': shangjia_about_contact_and_basic_info['_shangjia_normalLinePriceStr'],
                                    '变体库存': '',
                                    '属性1名': '',
                                    '属性1值': '',
                                    '属性2名': '',
                                    '属性2值': '',
                                    '属性3名': '',
                                    '属性3值': '',
                                    '属性4名': '',
                                    '属性4值': '',
                                    '主图': shangjia_about_contact_and_basic_info['_shangjia_hdThumbUrl'],
                                    '附图1': futu1,
                                    '附图2': futu2,
                                    '附图3': futu3,
                                    '附图4': futu4,
                                    '附图5': futu5,
                                    '附图6': futu6,
                                    '附图7': futu7,
                                    '附图8': futu8,
                                    '附图9': futu9,
                                    '附图10': futu10,
                                    '附图11': futu11,
                                    '附图12': futu12,
                                    '附图13': futu13,
                                    '附图14': futu14,
                                    '附图15': futu15,
                                    '附图16': futu16,
                                    '附图17': futu17,
                                    '附图18': futu18,
                                    '附图19': futu19,
                                    '附图20': futu20,
                                    'VideoUrl': shangjia_about_contact_and_basic_info['_shangjia_VideoUrl'],
                                    '物品详情':_body_html,
                                    '卖家提供的物品描述':_shangjia_description,
                                    //'描述图片': shangjia_about_contact_and_basic_info['_shangjia_productDetailFlatList'].join(','),
                                    //review
                                    //'review': shangjia_about_contact_and_basic_info['_shangjia_reivew_num'],
                                    'sold': _shangjia_sold,
                                    //store
                                    'store name': shangjia_about_contact_and_basic_info['_shangjia_store_name'],
                                    'store url': shangjia_about_contact_and_basic_info['_shangjia_store_url'],
                                    'store sold': shangjia_about_contact_and_basic_info['_shangjia_store_sold'],
                                    //'store review': shangjia_about_contact_and_basic_info['_shangjia_store_review_num'],
                                    //'store score': shangjia_about_contact_and_basic_info['_shangjia_store_score'],
                                    //'store followers': shangjia_about_contact_and_basic_info['_shangjia_store_followers'],
                                    //'store items': _shangjia_store_items
                                    //
                                    //'is request': shangjia_about_contact_and_basic_info['_is_request'] == 2 ? '已完成':'未',
                                }
                                export_datas.push(export_data_item);
                                //
                                //
                            }
                        }
                    }
                }
                //
                exportToExcel(export_datas, 'gycharm-ebay-export-'+Date.now(), "Sheet1");
                //
            });
            //
            $('#message-info').html('');
            //
        });
        //
    });
}

extract_catalog_products_export_clean();

function extract_catalog_products_export_shopify(){
    $('#extract-catalog-products-export-shopify').click(function (){
        util_check_is_maps_page();
        //
        $('#message-info').html('<span style="font-size: 12px;">提取需要花费时间，请保持界面不动,处理中...</span>')
        console.log('extract-catalog-products-export-shopify a1');
        //
        var bg = chrome.extension.getBackgroundPage();
        bg.storage_get(function (callback_data) {
            console.log('extract-catalog-products-export-shopify a2');
            console.log(callback_data);
            //
            let expire_date = callback_data['expire'];
            if(typeof expire_date === 'undefined'){
                $('.jihuo').show();
                $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin?plugin=vip_ebay_1nian&type=other_plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                return;
            }else{
                console.log('expire_date');
                console.log(expire_date);
                expire_date = expire_date.replace('T00:00:00.000Z','');
                $('#expire_date').html(expire_date);
                if (util_check_expire(expire_date)) {
                    $('.jihuo').show();
                    $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                    $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin?plugin=vip_ebay_1nian&type=other_plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                    return;
                }
            }

            //shopify格式导出
            chrome.storage.local.get(null, function(items) {
                let export_datas = [];
                //
                for (let key in items) {
                    if (key.indexOf('shangjia_about_contact_and_basic_info_') != -1) {
                        if (items[key]['_is_request'] == 2) {
                            let shangjia_about_contact_and_basic_info = items[key];
                            let _shangjia_goodsId = shangjia_about_contact_and_basic_info['_shangjia_goodsId']
                            if(_shangjia_goodsId == ''){
                                continue;
                            }
                            //
                            let _shangjia_variants_skus = shangjia_about_contact_and_basic_info['_shangjia_variants_skus'];
                            //
                            let _shangjia_gallery_arr = shangjia_about_contact_and_basic_info['_shangjia_gallery'];

                            let futu1 = '';
                            let futu2 = '';
                            let futu3 = '';
                            let futu4 = '';
                            let futu5 = '';

                            let futu6 = '';
                            let futu7 = '';
                            let futu8 = '';
                            let futu9 = '';
                            let futu10 = '';

                            let futu11 = '';
                            let futu12 = '';
                            let futu13 = '';
                            let futu14 = '';
                            let futu15 = '';

                            let futu16 = '';
                            let futu17 = '';
                            let futu18 = '';
                            let futu19 = '';
                            let futu20 = '';

                            if(_shangjia_gallery_arr.length>=1){
                                futu1 = _shangjia_gallery_arr[0];
                            }
                            if(_shangjia_gallery_arr.length>=2){
                                futu2 = _shangjia_gallery_arr[1];
                            }
                            if(_shangjia_gallery_arr.length>=3){
                                futu3 = _shangjia_gallery_arr[2];
                            }
                            if(_shangjia_gallery_arr.length>=4){
                                futu4 = _shangjia_gallery_arr[3];
                            }
                            if(_shangjia_gallery_arr.length>=5){
                                futu5 = _shangjia_gallery_arr[4];
                            }
                            if(_shangjia_gallery_arr.length>=6){
                                futu6 = _shangjia_gallery_arr[5];
                            }
                            if(_shangjia_gallery_arr.length>=7){
                                futu7 = _shangjia_gallery_arr[6];
                            }
                            if(_shangjia_gallery_arr.length>=8){
                                futu8 = _shangjia_gallery_arr[7];
                            }
                            if(_shangjia_gallery_arr.length>=9){
                                futu9 = _shangjia_gallery_arr[8];
                            }
                            if(_shangjia_gallery_arr.length>=10){
                                futu10 = _shangjia_gallery_arr[9];
                            }
                            if(_shangjia_gallery_arr.length>=11){
                                futu11 = _shangjia_gallery_arr[10];
                            }
                            if(_shangjia_gallery_arr.length>=12){
                                futu12 = _shangjia_gallery_arr[11];
                            }
                            if(_shangjia_gallery_arr.length>=13){
                                futu13 = _shangjia_gallery_arr[12];
                            }
                            if(_shangjia_gallery_arr.length>=14){
                                futu14 = _shangjia_gallery_arr[13];
                            }
                            if(_shangjia_gallery_arr.length>=15){
                                futu15 = _shangjia_gallery_arr[14];
                            }
                            if(_shangjia_gallery_arr.length>=16){
                                futu16 = _shangjia_gallery_arr[15];
                            }
                            if(_shangjia_gallery_arr.length>=17){
                                futu17 = _shangjia_gallery_arr[16];
                            }
                            if(_shangjia_gallery_arr.length>=18){
                                futu18 = _shangjia_gallery_arr[17];
                            }
                            if(_shangjia_gallery_arr.length>=19){
                                futu19 = _shangjia_gallery_arr[18];
                            }
                            if(_shangjia_gallery_arr.length>=20){
                                futu20 = _shangjia_gallery_arr[19];
                            }
                            //
                            let _shangjia_sold = shangjia_about_contact_and_basic_info['_shangjia_sold'];
                            //
                            let _shangjia_store_items = shangjia_about_contact_and_basic_info['_shangjia_store_items'];
                            if(_shangjia_store_items){
                                _shangjia_store_items = _shangjia_store_items.replace('Items','');
                                _shangjia_store_items = _shangjia_store_items.trim();
                            }
                            //
                            let _body_html = shangjia_about_contact_and_basic_info['_shangjia_goodsProperty'];
                            let _shangjia_description = shangjia_about_contact_and_basic_info['_shangjia_description'];
                            if(_shangjia_description.length > 32767){
                                //_shangjia_description = '';
                            }
                            //
                            let handle = _shangjia_goodsId+'-item';
                            //
                            if(_shangjia_variants_skus.length > 0){
                                for(let i=0;i<_shangjia_variants_skus.length;i++){
                                    //
                                    let imgsrc = '';
                                    if(i==0){
                                        imgsrc = futu1;
                                    }else if(i==1){
                                        imgsrc = futu2;
                                    }else if(i==2){
                                        imgsrc = futu3;
                                    }else if(i==3){
                                        imgsrc = futu4;
                                    }else if(i==4){
                                        imgsrc = futu5;
                                    }else if(i==5){
                                        imgsrc = futu6;
                                    }else if(i==6){
                                        imgsrc = futu7;
                                    }else if(i==7){
                                        imgsrc = futu8;
                                    }else if(i==8){
                                        imgsrc = futu9;
                                    }else if(i==9){
                                        imgsrc = futu10;
                                    }else if(i==10){
                                        imgsrc = futu11;
                                    }else if(i==11){
                                        imgsrc = futu12;
                                    }else if(i==12){
                                        imgsrc = futu13;
                                    }else if(i==13){
                                        imgsrc = futu14;
                                    }else if(i==14){
                                        imgsrc = futu15;
                                    }else if(i==15){
                                        imgsrc = futu16;
                                    }else if(i==16){
                                        imgsrc = futu17;
                                    }else if(i==17){
                                        imgsrc = futu18;
                                    }else if(i==18){
                                        imgsrc = futu19;
                                    }else if(i==19){
                                        imgsrc = futu20;
                                    }
                                    //
                                    let specs_key1_name = _shangjia_variants_skus[i]['specs_key1_name'];
                                    let specs_key2_name = _shangjia_variants_skus[i]['specs_key2_name'];
                                    let specs_key3_name = _shangjia_variants_skus[i]['specs_key3_name'];
                                    let specs_key4_name = _shangjia_variants_skus[i]['specs_key4_name'];
                                    //
                                    let _skuId = _shangjia_variants_skus[i]['skuId'];
                                    _skuId = 'S'+_skuId;
                                    let normalLinePriceStr = _shangjia_variants_skus[i]['normalLinePriceStr'];
                                    let normalPriceStr = _shangjia_variants_skus[i]['normalPriceStr'];
                                    let export_data_item = {
                                        'Handle': handle,
                                        'Title': i==0?shangjia_about_contact_and_basic_info['_shangjia_goodsName']:'',
                                        'Body (HTML)': i==0?_body_html+_shangjia_description:'',
                                        'Vendor': i==0?'mysite':'',
                                        'Type':'',
                                        'Tags':'',
                                        'Published':i==0?'TRUE':'',
                                        'Option1 Name': specs_key1_name,
                                        'Option1 Value': _shangjia_variants_skus[i]['specs_key1_value'],
                                        'Option2 Name': specs_key2_name,
                                        'Option2 Value': _shangjia_variants_skus[i]['specs_key2_value'],
                                        'Option3 Name': specs_key3_name,
                                        'Option3 Value': _shangjia_variants_skus[i]['specs_key3_value'],
                                        'Variant SKU': _skuId,
                                        'Variant Grams': 0,
                                        'Variant Inventory Tracker':'shopify',
                                        'Variant Inventory Qty': _shangjia_variants_skus[i]['stockQuantity'],
                                        'Variant Inventory Policy':'continue',
                                        'Variant Fulfillment Service':'manual',
                                        'Variant Price':normalPriceStr,
                                        'Variant Compare At Price':normalLinePriceStr,
                                        'Variant Requires Shipping':'TRUE',
                                        'Variant Taxable':'TRUE',
                                        'Variant Barcode':'',
                                        'Image Src': imgsrc,
                                        'Image Position': imgsrc?(i+1):'',
                                        'Image Alt Text':'',
                                        'Gift Card': i==0?'FALSE':'',
                                        'SEO Title': i==0?shangjia_about_contact_and_basic_info['_shangjia_goodsName']:'',
                                        'SEO Description': i==0?shangjia_about_contact_and_basic_info['_shangjia_goodsName']:'',
                                        'Google Shopping / Google Product Category':'',
                                        'Google Shopping / Gender':'',
                                        'Google Shopping / Age Group':'',
                                        'Google Shopping / MPN':'',
                                        'Google Shopping / AdWords Grouping':'',
                                        'Google Shopping / AdWords Labels':'',
                                        'Google Shopping / Condition':'',
                                        'Google Shopping / Custom Product':'',
                                        'Google Shopping / Custom Label 0':'',
                                        'Google Shopping / Custom Label 1':'',
                                        'Google Shopping / Custom Label 2':'',
                                        'Google Shopping / Custom Label 3':'',
                                        'Google Shopping / Custom Label 4':'',
                                        'Variant Image': _shangjia_variants_skus[i]['img'],
                                        'Variant Weight Unit':'',
                                        'Variant Tax Code':'',
                                        'Cost per item':'',
                                        'Status':i==0?'active':''
                                    }
                                    export_datas.push(export_data_item);
                                    //
                                }
                                //
                                if(_shangjia_gallery_arr.length > _shangjia_variants_skus.length){
                                    //
                                    for(let _g=_shangjia_variants_skus.length;_g<_shangjia_gallery_arr.length;_g++){
                                        let export_data_item = {
                                            'Handle': handle,
                                            'Title': '',
                                            'Body (HTML)': '',
                                            'Vendor': '',
                                            'Type':'',
                                            'Tags':'',
                                            'Published':'',
                                            'Option1 Name': '',
                                            'Option1 Value': '',
                                            'Option2 Name': '',
                                            'Option2 Value': '',
                                            'Option3 Name': '',
                                            'Option3 Value': '',
                                            'Variant SKU': '',
                                            'Variant Grams': '',
                                            'Variant Inventory Tracker':'',
                                            'Variant Inventory Qty': '',
                                            'Variant Inventory Policy':'',
                                            'Variant Fulfillment Service':'',
                                            'Variant Price':'',
                                            'Variant Compare At Price':'',
                                            'Variant Requires Shipping':'',
                                            'Variant Taxable':'',
                                            'Variant Barcode':'',
                                            'Image Src': _shangjia_gallery_arr[_g],
                                            'Image Position': (_g+1),
                                            'Image Alt Text':'',
                                            'Gift Card': '',
                                            'SEO Title': '',
                                            'SEO Description': '',
                                            'Google Shopping / Google Product Category':'',
                                            'Google Shopping / Gender':'',
                                            'Google Shopping / Age Group':'',
                                            'Google Shopping / MPN':'',
                                            'Google Shopping / AdWords Grouping':'',
                                            'Google Shopping / AdWords Labels':'',
                                            'Google Shopping / Condition':'',
                                            'Google Shopping / Custom Product':'',
                                            'Google Shopping / Custom Label 0':'',
                                            'Google Shopping / Custom Label 1':'',
                                            'Google Shopping / Custom Label 2':'',
                                            'Google Shopping / Custom Label 3':'',
                                            'Google Shopping / Custom Label 4':'',
                                            'Variant Image': '',
                                            'Variant Weight Unit':'',
                                            'Variant Tax Code':'',
                                            'Cost per item':'',
                                            'Status':''
                                        }
                                        export_datas.push(export_data_item);
                                    }
                                    //
                                }
                                //
                            }else{
                                //
                                let export_data_item = {
                                        'Handle': handle,
                                        'Title': shangjia_about_contact_and_basic_info['_shangjia_goodsName'],
                                        'Body (HTML)': _body_html+_shangjia_description,
                                        'Vendor': 'mysite',
                                        'Type':'',
                                        'Tags':'',
                                        'Published':'TRUE',
                                        'Option1 Name': '',
                                        'Option1 Value': '',
                                        'Option2 Name': '',
                                        'Option2 Value': '',
                                        'Option3 Name': '',
                                        'Option3 Value': '',
                                        'Variant SKU': 'S'+_shangjia_goodsId,
                                        'Variant Grams': 0,
                                        'Variant Inventory Tracker':'shopify',
                                        'Variant Inventory Qty': shangjia_about_contact_and_basic_info['_shangjia_quantity'],
                                        'Variant Inventory Policy':'continue',
                                        'Variant Fulfillment Service':'manual',
                                        'Variant Price':shangjia_about_contact_and_basic_info['_shangjia_minOnSalePriceStr'],
                                        'Variant Compare At Price':shangjia_about_contact_and_basic_info['_shangjia_normalLinePriceStr'],
                                        'Variant Requires Shipping':'TRUE',
                                        'Variant Taxable':'TRUE',
                                        'Variant Barcode':'',
                                        'Image Src': shangjia_about_contact_and_basic_info['_shangjia_hdThumbUrl'],
                                        'Image Position': 1,
                                        'Image Alt Text':'',
                                        'Gift Card': 'FALSE',
                                        'SEO Title': shangjia_about_contact_and_basic_info['_shangjia_goodsName'],
                                        'SEO Description': shangjia_about_contact_and_basic_info['_shangjia_goodsName'],
                                        'Google Shopping / Google Product Category':'',
                                        'Google Shopping / Gender':'',
                                        'Google Shopping / Age Group':'',
                                        'Google Shopping / MPN':'',
                                        'Google Shopping / AdWords Grouping':'',
                                        'Google Shopping / AdWords Labels':'',
                                        'Google Shopping / Condition':'',
                                        'Google Shopping / Custom Product':'',
                                        'Google Shopping / Custom Label 0':'',
                                        'Google Shopping / Custom Label 1':'',
                                        'Google Shopping / Custom Label 2':'',
                                        'Google Shopping / Custom Label 3':'',
                                        'Google Shopping / Custom Label 4':'',
                                        'Variant Image': '',
                                        'Variant Weight Unit':'',
                                        'Variant Tax Code':'',
                                        'Cost per item':'',
                                        'Status':'active'
                                }
                                export_datas.push(export_data_item);
                                //
                                for(let _g=1;_g<_shangjia_gallery_arr.length;_g++){
                                    let export_data_item = {
                                        'Handle': handle,
                                        'Title': '',
                                        'Body (HTML)': '',
                                        'Vendor': '',
                                        'Type':'',
                                        'Tags':'',
                                        'Published':'',
                                        'Option1 Name': '',
                                        'Option1 Value': '',
                                        'Option2 Name': '',
                                        'Option2 Value': '',
                                        'Option3 Name': '',
                                        'Option3 Value': '',
                                        'Variant SKU': '',
                                        'Variant Grams': '',
                                        'Variant Inventory Tracker':'',
                                        'Variant Inventory Qty': '',
                                        'Variant Inventory Policy':'',
                                        'Variant Fulfillment Service':'',
                                        'Variant Price':'',
                                        'Variant Compare At Price':'',
                                        'Variant Requires Shipping':'',
                                        'Variant Taxable':'',
                                        'Variant Barcode':'',
                                        'Image Src': _shangjia_gallery_arr[_g],
                                        'Image Position': (_g+1),
                                        'Image Alt Text':'',
                                        'Gift Card': '',
                                        'SEO Title': '',
                                        'SEO Description': '',
                                        'Google Shopping / Google Product Category':'',
                                        'Google Shopping / Gender':'',
                                        'Google Shopping / Age Group':'',
                                        'Google Shopping / MPN':'',
                                        'Google Shopping / AdWords Grouping':'',
                                        'Google Shopping / AdWords Labels':'',
                                        'Google Shopping / Condition':'',
                                        'Google Shopping / Custom Product':'',
                                        'Google Shopping / Custom Label 0':'',
                                        'Google Shopping / Custom Label 1':'',
                                        'Google Shopping / Custom Label 2':'',
                                        'Google Shopping / Custom Label 3':'',
                                        'Google Shopping / Custom Label 4':'',
                                        'Variant Image': '',
                                        'Variant Weight Unit':'',
                                        'Variant Tax Code':'',
                                        'Cost per item':'',
                                        'Status':''
                                    }
                                    export_datas.push(export_data_item);
                                }
                                //
                            }

                        }
                    }
                }
                //
                exportToCsv(export_datas, 'gycharm-ebay-shopify-export-'+Date.now(), "Sheet1");
                //
            });
            //
            $('#message-info').html('');
            //
        });
        //
    });
}

extract_catalog_products_export_shopify();

function extract_catalog_products_export_tiktok(){
    $('#extract-catalog-products-export-tiktok').click(function (){
         //
        $('#message-info').html('<span style="font-size: 12px;">提取需要花费时间，请保持界面不动,处理中...</span>')
        console.log('extract_catalog_products_export_tiktok');
        //
        var bg = chrome.extension.getBackgroundPage();
        bg.storage_get(function (callback_data) {
            console.log('extract_catalog_products_export_clean');
            console.log(callback_data);
            //
            let expire_date = callback_data['expire'];
            if(typeof expire_date === 'undefined'){
                $('.jihuo').show();
                $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin?plugin=vip_ebay_1nian&type=other_plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                return;
            }else{
                console.log('expire_date');
                console.log(expire_date);
                expire_date = expire_date.replace('T00:00:00.000Z','');
                $('#expire_date').html(expire_date);
                if (util_check_expire(expire_date)) {
                    $('.jihuo').show();
                    $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                    $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin?plugin=vip_ebay_1nian&type=other_plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                    return;
                }
            }
            //tiktok导出
            chrome.storage.local.get(null, function(items) {
                let export_datas = [];
                //
                for (let key in items) {
                    if (key.indexOf('shangjia_about_contact_and_basic_info_') != -1) {
                        if (items[key]['_is_request'] == 2) {
                            let shangjia_about_contact_and_basic_info = items[key];
                            let _shangjia_goodsId = shangjia_about_contact_and_basic_info['_shangjia_goodsId']
                            if(_shangjia_goodsId == ''){
                                continue;
                            }
                            //
                            let _shangjia_variants_skus = shangjia_about_contact_and_basic_info['_shangjia_variants_skus'];
                            //
                            let _shangjia_gallery_arr = shangjia_about_contact_and_basic_info['_shangjia_gallery'];

                            let futu1 = '';
                            let futu2 = '';
                            let futu3 = '';
                            let futu4 = '';
                            let futu5 = '';

                            let futu6 = '';
                            let futu7 = '';
                            let futu8 = '';
                            let futu9 = '';
                            let futu10 = '';

                            let futu11 = '';
                            let futu12 = '';
                            let futu13 = '';
                            let futu14 = '';
                            let futu15 = '';

                            let futu16 = '';
                            let futu17 = '';
                            let futu18 = '';
                            let futu19 = '';
                            let futu20 = '';

                            if(_shangjia_gallery_arr.length>=1){
                                futu1 = _shangjia_gallery_arr[0];
                            }
                            if(_shangjia_gallery_arr.length>=2){
                                futu2 = _shangjia_gallery_arr[1];
                            }
                            if(_shangjia_gallery_arr.length>=3){
                                futu3 = _shangjia_gallery_arr[2];
                            }
                            if(_shangjia_gallery_arr.length>=4){
                                futu4 = _shangjia_gallery_arr[3];
                            }
                            if(_shangjia_gallery_arr.length>=5){
                                futu5 = _shangjia_gallery_arr[4];
                            }
                            if(_shangjia_gallery_arr.length>=6){
                                futu6 = _shangjia_gallery_arr[5];
                            }
                            if(_shangjia_gallery_arr.length>=7){
                                futu7 = _shangjia_gallery_arr[6];
                            }
                            if(_shangjia_gallery_arr.length>=8){
                                futu8 = _shangjia_gallery_arr[7];
                            }
                            if(_shangjia_gallery_arr.length>=9){
                                futu9 = _shangjia_gallery_arr[8];
                            }
                            if(_shangjia_gallery_arr.length>=10){
                                futu10 = _shangjia_gallery_arr[9];
                            }
                            if(_shangjia_gallery_arr.length>=11){
                                futu11 = _shangjia_gallery_arr[10];
                            }
                            if(_shangjia_gallery_arr.length>=12){
                                futu12 = _shangjia_gallery_arr[11];
                            }
                            if(_shangjia_gallery_arr.length>=13){
                                futu13 = _shangjia_gallery_arr[12];
                            }
                            if(_shangjia_gallery_arr.length>=14){
                                futu14 = _shangjia_gallery_arr[13];
                            }
                            if(_shangjia_gallery_arr.length>=15){
                                futu15 = _shangjia_gallery_arr[14];
                            }
                            if(_shangjia_gallery_arr.length>=16){
                                futu16 = _shangjia_gallery_arr[15];
                            }
                            if(_shangjia_gallery_arr.length>=17){
                                futu17 = _shangjia_gallery_arr[16];
                            }
                            if(_shangjia_gallery_arr.length>=18){
                                futu18 = _shangjia_gallery_arr[17];
                            }
                            if(_shangjia_gallery_arr.length>=19){
                                futu19 = _shangjia_gallery_arr[18];
                            }
                            if(_shangjia_gallery_arr.length>=20){
                                futu20 = _shangjia_gallery_arr[19];
                            }
                            //
                            let _shangjia_sold = shangjia_about_contact_and_basic_info['_shangjia_sold'];
                            //
                            let _shangjia_store_items = shangjia_about_contact_and_basic_info['_shangjia_store_items'];
                            //
                            let _body_html = shangjia_about_contact_and_basic_info['_shangjia_goodsProperty'];
                            let _shangjia_description = shangjia_about_contact_and_basic_info['_shangjia_description'];
                            if(_shangjia_description.length > 32767){
                                _shangjia_description = '';
                            }
                            //
                            let _category = shangjia_about_contact_and_basic_info['_shangjia_category'];
                            let _category_str = '';
                            let _category_arr = _category.split('>');
                            if(_category_arr.length>=2){
                                _category_str = _category_arr[1];
                            }else{
                                _category_str = _category_arr[0];
                            }
                            _category_str = _category_str.trim();
                            //
                            if(_shangjia_variants_skus.length > 0){
                                for(let i=0;i<_shangjia_variants_skus.length;i++){
                                    //
                                    let specs_key1_name = _shangjia_variants_skus[i]['specs_key1_name'];
                                    let specs_key2_name = _shangjia_variants_skus[i]['specs_key2_name'];
                                    let specs_key3_name = _shangjia_variants_skus[i]['specs_key3_name'];
                                    let specs_key4_name = _shangjia_variants_skus[i]['specs_key4_name'];
                                    //
                                    let _skuId = _shangjia_variants_skus[i]['skuId'];
                                    _skuId = 'T'+_skuId;
                                    //
                                    let export_data_item = {
                                        'Category': _category_str,
                                        'Brand':'',
                                        'Product Name': shangjia_about_contact_and_basic_info['_shangjia_goodsName'],
                                        'Product Description': _body_html+_shangjia_description,
                                        'Package Weight(lb)':'',
                                        'Package Length(inch)':'',
                                        'Package Width(inch)':'',
                                        'Package Height(inch)':'',
                                        'Delivery options':'Default',
                                        'Identifier Code Type':'',
                                        'Identifier Code':'',
                                        '属性1名': specs_key1_name,
                                        'Variation 1': _shangjia_variants_skus[i]['specs_key1_value'],
                                        '属性2名': specs_key2_name,
                                        'Variation 2': _shangjia_variants_skus[i]['specs_key2_value'],
                                        '属性3名': specs_key3_name,
                                        'Variation 3': _shangjia_variants_skus[i]['specs_key3_value'],
                                        '属性4名': specs_key4_name,
                                        'Variation 4': _shangjia_variants_skus[i]['specs_key4_value'],
                                        'Variant Image': _shangjia_variants_skus[i]['img'],
                                        'Retail Price (Local Currency)': _shangjia_variants_skus[i]['normalPriceStr'],
                                        'Quantity in RUIZ SPORT STORE': _shangjia_variants_skus[i]['stockQuantity'],
                                        'Seller SKU': _skuId,
                                        'Main Product Image': _shangjia_variants_skus[i]['img'],
                                        'Product Image 2': futu1,
                                        'Product Image 3': futu2,
                                        'Product Image 4': futu3,
                                        'Product Image 5': futu4,
                                        'Product Image 6': futu5,
                                        'Product Image 7': futu6,
                                        'Product Image 8': futu7,
                                        'Product Image 9': futu8,
                                        'Product Image 10': futu9,
                                        'Product Image 11': futu10,
                                        'Product Image 12': futu11,
                                        'Product Image 13': futu12,
                                        'Product Image 14': futu13,
                                        'Product Image 15': futu14,
                                        'Product Image 16': futu15,
                                        'Product Image 17': futu16,
                                        'Product Image 18': futu17,
                                        'Product Image 19': futu18,
                                        'Product Image 20': futu19,
                                        'Product Image 21': futu20,
                                        'Size Chart':'',
                                        'Product Status':'',
                                    }
                                    export_datas.push(export_data_item);
                                    //
                                }
                            }else{
                                //
                                let export_data_item = {
                                    'Category': _category_str,
                                    'Brand':'',
                                    'Product Name': shangjia_about_contact_and_basic_info['_shangjia_goodsName'],
                                    'Product Description': _body_html+_shangjia_description,
                                    'Package Weight(lb)':'',
                                    'Package Length(inch)':'',
                                    'Package Width(inch)':'',
                                    'Package Height(inch)':'',
                                    'Delivery options':'Default',
                                    'Identifier Code Type':'',
                                    'Identifier Code':'',
                                    '属性1名': '',
                                    'Variation 1': '',
                                    '属性2名': '',
                                    'Variation 2': '',
                                    '属性3名': '',
                                    'Variation 3': '',
                                    '属性4名': '',
                                    'Variation 4': '',
                                    'Variant Image': '',
                                    'Retail Price (Local Currency)': shangjia_about_contact_and_basic_info['_shangjia_minOnSalePriceStr'],
                                    'Quantity in RUIZ SPORT STORE': shangjia_about_contact_and_basic_info['_shangjia_quantity'],
                                    'Seller SKU': 'T'+_shangjia_goodsId,
                                    'Main Product Image': shangjia_about_contact_and_basic_info['_shangjia_hdThumbUrl'],
                                    'Product Image 2': futu1,
                                    'Product Image 3': futu2,
                                    'Product Image 4': futu3,
                                    'Product Image 5': futu4,
                                    'Product Image 6': futu5,
                                    'Product Image 7': futu6,
                                    'Product Image 8': futu7,
                                    'Product Image 9': futu8,
                                    'Product Image 10': futu9,
                                    'Product Image 11': futu10,
                                    'Product Image 12': futu11,
                                    'Product Image 13': futu12,
                                    'Product Image 14': futu13,
                                    'Product Image 15': futu14,
                                    'Product Image 16': futu15,
                                    'Product Image 17': futu16,
                                    'Product Image 18': futu17,
                                    'Product Image 19': futu18,
                                    'Product Image 20': futu19,
                                    'Product Image 21': futu20,
                                    'Size Chart':'',
                                    'Product Status':'',
                                }
                                export_datas.push(export_data_item);
                                //
                                //
                            }
                        }
                    }
                }
                //
                exportToExcel(export_datas, 'gycharm-ebay-tiktok-export-'+Date.now(), "Sheet1");
                //
            });
            //
            $('#message-info').html('');
            //
        });
        //
    });
}

extract_catalog_products_export_tiktok();

function extract_catalog_products_export_dingzhi(){
    $('#extract-catalog-products-export-dingzhi').click(function (){
        util_check_is_maps_page();
        //
         //
        $('#message-info').html('<span style="font-size: 12px;">提取需要花费时间，请保持界面不动,处理中...</span>')
        console.log('extract-catalog-products-url');
        //
        var bg = chrome.extension.getBackgroundPage();
        bg.storage_get(function (callback_data) {
            console.log('extract_catalog_products_export_clean');
            console.log(callback_data);
            //
            let expire_date = callback_data['expire'];
            if(typeof expire_date === 'undefined'){
                $('.jihuo').show();
                $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin?plugin=vip_ebay_1nian&type=other_plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                return;
            }else{
                console.log('expire_date');
                console.log(expire_date);
                expire_date = expire_date.replace('T00:00:00.000Z','');
                $('#expire_date').html(expire_date);
                if (util_check_expire(expire_date)) {
                    $('.jihuo').show();
                    $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                    $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin?plugin=vip_ebay_1nian&type=other_plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                    return;
                }
            }

            ///////
            let export_datas = [];
            let export_datas2 = [];
            let file_name = $('#field_name').val();
            file_name = file_name.trim();
            //定制导出的
            chrome.storage.local.get(null, function(items) {
                //导出一
                for (let key in items) {
                    if (key.indexOf('shangjia_about_contact_and_basic_info_') != -1) {
                        if (items[key]['_is_request'] == 2) {
                            let shangjia_about_contact_and_basic_info = items[key];
                            let _shangjia_goodsId = shangjia_about_contact_and_basic_info['_shangjia_goodsId']
                            if(_shangjia_goodsId == ''){
                                continue;
                            }
                            //
                            let _shangjia_variants_skus = shangjia_about_contact_and_basic_info['_shangjia_variants_skus'];
                            //
                            let _shangjia_gallery_arr = shangjia_about_contact_and_basic_info['_shangjia_gallery'];

                            let futu1 = '';
                            let futu2 = '';
                            let futu3 = '';
                            let futu4 = '';
                            let futu5 = '';

                            let futu6 = '';
                            let futu7 = '';
                            let futu8 = '';
                            let futu9 = '';
                            let futu10 = '';

                            let futu11 = '';
                            let futu12 = '';
                            let futu13 = '';
                            let futu14 = '';
                            let futu15 = '';

                            let futu16 = '';
                            let futu17 = '';
                            let futu18 = '';
                            let futu19 = '';
                            let futu20 = '';

                            if(_shangjia_gallery_arr.length>=1){
                                futu1 = _shangjia_gallery_arr[0];
                            }
                            if(_shangjia_gallery_arr.length>=2){
                                futu2 = _shangjia_gallery_arr[1];
                            }
                            if(_shangjia_gallery_arr.length>=3){
                                futu3 = _shangjia_gallery_arr[2];
                            }
                            if(_shangjia_gallery_arr.length>=4){
                                futu4 = _shangjia_gallery_arr[3];
                            }
                            if(_shangjia_gallery_arr.length>=5){
                                futu5 = _shangjia_gallery_arr[4];
                            }
                            if(_shangjia_gallery_arr.length>=6){
                                futu6 = _shangjia_gallery_arr[5];
                            }
                            if(_shangjia_gallery_arr.length>=7){
                                futu7 = _shangjia_gallery_arr[6];
                            }
                            if(_shangjia_gallery_arr.length>=8){
                                futu8 = _shangjia_gallery_arr[7];
                            }
                            if(_shangjia_gallery_arr.length>=9){
                                futu9 = _shangjia_gallery_arr[8];
                            }
                            if(_shangjia_gallery_arr.length>=10){
                                futu10 = _shangjia_gallery_arr[9];
                            }
                            if(_shangjia_gallery_arr.length>=11){
                                futu11 = _shangjia_gallery_arr[10];
                            }
                            if(_shangjia_gallery_arr.length>=12){
                                futu12 = _shangjia_gallery_arr[11];
                            }
                            if(_shangjia_gallery_arr.length>=13){
                                futu13 = _shangjia_gallery_arr[12];
                            }
                            if(_shangjia_gallery_arr.length>=14){
                                futu14 = _shangjia_gallery_arr[13];
                            }
                            if(_shangjia_gallery_arr.length>=15){
                                futu15 = _shangjia_gallery_arr[14];
                            }
                            if(_shangjia_gallery_arr.length>=16){
                                futu16 = _shangjia_gallery_arr[15];
                            }
                            if(_shangjia_gallery_arr.length>=17){
                                futu17 = _shangjia_gallery_arr[16];
                            }
                            if(_shangjia_gallery_arr.length>=18){
                                futu18 = _shangjia_gallery_arr[17];
                            }
                            if(_shangjia_gallery_arr.length>=19){
                                futu19 = _shangjia_gallery_arr[18];
                            }
                            if(_shangjia_gallery_arr.length>=20){
                                futu20 = _shangjia_gallery_arr[19];
                            }
                            //
                            for(let i=0;i<_shangjia_variants_skus.length;i++){
                                //
                                let specs_key1_name = _shangjia_variants_skus[i]['specs_key1_name'];
                                let specs_key2_name = _shangjia_variants_skus[i]['specs_key2_name'];
                                let specs_key3_name = _shangjia_variants_skus[i]['specs_key3_name'];
                                let specs_key4_name = _shangjia_variants_skus[i]['specs_key4_name'];
                                //
                                let export_data_item = {
                                    'ParentSKU': shangjia_about_contact_and_basic_info['_shangjia_goodsId'],
                                    'SKU': _shangjia_variants_skus[i]['subsku'],
                                    '产品标题': shangjia_about_contact_and_basic_info['_shangjia_goodsName'],
                                    '产品描述': shangjia_about_contact_and_basic_info['_shangjia_goodsProperty'],
                                    '产品标签':'',
                                    '品牌':'',
                                    'UPC':'',
                                    'LandingPageUrl':'',
                                    'MSRP':'',
                                    '颜色': _shangjia_variants_skus[i]['specs_key1_value'],
                                    '尺寸值': _shangjia_variants_skus[i]['specs_key2_value'],
                                    '来源url':'',
                                    '价格': _shangjia_variants_skus[i]['normalPriceStr'].replace('$',''),
                                    '运费':'',
                                    '数量':'100',
                                    '最小送达时间':'',
                                    '最大送达时间':'',
                                    '主图': shangjia_about_contact_and_basic_info['_shangjia_hdThumbUrl'],
                                    '附图1': futu1,
                                    '附图2': futu2,
                                    '附图3': futu3,
                                    '附图4': futu4,
                                    '附图5': futu5,
                                    '附图6': futu6,
                                    '附图7': futu7,
                                    '附图8': futu8,
                                    '附图9': futu9,
                                    '附图10': futu10,
                                    '附图11': futu11,
                                    '附图12': futu12,
                                    '附图13': futu13,
                                    '附图14': futu14,
                                    '附图15': futu15,
                                    '附图16': futu16,
                                    '附图17': futu17,
                                    '附图18': futu18,
                                    '附图19': futu19,
                                    '附图20': futu20,

                                    '产品地址': shangjia_about_contact_and_basic_info['_shangjia_about_contact_and_basic_info_link'],
                                    '描述图片':'',
                                    '变种图（URL）地址': _shangjia_variants_skus[i]['img'],
                                    'ShippingWeight':'',
                                    'VariantMainImageURL':shangjia_about_contact_and_basic_info['_shangjia_hdThumbUrl'],
                                    'DescHtml': shangjia_about_contact_and_basic_info['_shangjia_goodsProperty'],
                                    'PubField1':'',
                                    'PubField2':'',
                                    'PubField3':'',
                                    'PubField4':'',
                                    'PubField5':'',
                                    'PubField6':'',
                                    'FenleiId':'',
                                    'FenleiName':'',
                                    'Category': shangjia_about_contact_and_basic_info['_shangjia_category'],
                                    'VideoUrl': shangjia_about_contact_and_basic_info['_shangjia_VideoUrl'],
                                    '原标题':shangjia_about_contact_and_basic_info['_shangjia_goodsName'],
                                    '语种':'',
                                    '包裹长度':'',
                                    '包裹宽度':'',
                                    '包裹高度':'',
                                    'EAN':'',
                                    '预留3':''
                                    //review

                                    //store
                                    //
                                    //'is request': shangjia_about_contact_and_basic_info['_is_request'] == 2 ? '已完成':'未',
                                }
                                export_datas.push(export_data_item);
                                //
                            }
                        }
                    }
                }
                //
                exportToExcel(export_datas, 'PGMY'+file_name, "Sheet1");
                //导出二
                //
                for (let key in items) {
                    if (key.indexOf('shangjia_about_contact_and_basic_info_') != -1) {
                        if (items[key]['_is_request'] == 2) {
                            let shangjia_about_contact_and_basic_info = items[key];
                            //
                            let _shangjia_variants_skus = shangjia_about_contact_and_basic_info['_shangjia_variants_skus'];
                            //
                            let _shangjia_gallery_arr = shangjia_about_contact_and_basic_info['_shangjia_gallery'];

                            let futu1 = '';
                            let futu2 = '';
                            let futu3 = '';
                            let futu4 = '';
                            let futu5 = '';

                            let futu6 = '';
                            let futu7 = '';
                            let futu8 = '';
                            let futu9 = '';
                            let futu10 = '';

                            let futu11 = '';
                            let futu12 = '';
                            let futu13 = '';
                            let futu14 = '';
                            let futu15 = '';

                            let futu16 = '';
                            let futu17 = '';
                            let futu18 = '';
                            let futu19 = '';
                            let futu20 = '';

                            if(_shangjia_gallery_arr.length>=1){
                                futu1 = _shangjia_gallery_arr[0];
                            }
                            if(_shangjia_gallery_arr.length>=2){
                                futu2 = _shangjia_gallery_arr[1];
                            }
                            if(_shangjia_gallery_arr.length>=3){
                                futu3 = _shangjia_gallery_arr[2];
                            }
                            if(_shangjia_gallery_arr.length>=4){
                                futu4 = _shangjia_gallery_arr[3];
                            }
                            if(_shangjia_gallery_arr.length>=5){
                                futu5 = _shangjia_gallery_arr[4];
                            }
                            if(_shangjia_gallery_arr.length>=6){
                                futu6 = _shangjia_gallery_arr[5];
                            }
                            if(_shangjia_gallery_arr.length>=7){
                                futu7 = _shangjia_gallery_arr[6];
                            }
                            if(_shangjia_gallery_arr.length>=8){
                                futu8 = _shangjia_gallery_arr[7];
                            }
                            if(_shangjia_gallery_arr.length>=9){
                                futu9 = _shangjia_gallery_arr[8];
                            }
                            if(_shangjia_gallery_arr.length>=10){
                                futu10 = _shangjia_gallery_arr[9];
                            }
                            if(_shangjia_gallery_arr.length>=11){
                                futu11 = _shangjia_gallery_arr[10];
                            }
                            if(_shangjia_gallery_arr.length>=12){
                                futu12 = _shangjia_gallery_arr[11];
                            }
                            if(_shangjia_gallery_arr.length>=13){
                                futu13 = _shangjia_gallery_arr[12];
                            }
                            if(_shangjia_gallery_arr.length>=14){
                                futu14 = _shangjia_gallery_arr[13];
                            }
                            if(_shangjia_gallery_arr.length>=15){
                                futu15 = _shangjia_gallery_arr[14];
                            }
                            if(_shangjia_gallery_arr.length>=16){
                                futu16 = _shangjia_gallery_arr[15];
                            }
                            if(_shangjia_gallery_arr.length>=17){
                                futu17 = _shangjia_gallery_arr[16];
                            }
                            if(_shangjia_gallery_arr.length>=18){
                                futu18 = _shangjia_gallery_arr[17];
                            }
                            if(_shangjia_gallery_arr.length>=19){
                                futu19 = _shangjia_gallery_arr[18];
                            }
                            if(_shangjia_gallery_arr.length>=20){
                                futu20 = _shangjia_gallery_arr[19];
                            }
                            //
                            for(let i=0;i<_shangjia_variants_skus.length;i++){
                                //
                                let specs_key1_name = _shangjia_variants_skus[i]['specs_key1_name'];
                                let specs_key2_name = _shangjia_variants_skus[i]['specs_key2_name'];
                                let specs_key3_name = _shangjia_variants_skus[i]['specs_key3_name'];
                                let specs_key4_name = _shangjia_variants_skus[i]['specs_key4_name'];
                                //
                                let export_data_item = {
                                    'Category': shangjia_about_contact_and_basic_info['_shangjia_category'],
                                    'Product Name': shangjia_about_contact_and_basic_info['_shangjia_goodsName'],
                                    'Model':'',
                                    'Brand':'NoBrand',
                                    'Manufacturing Country': 'Not Specified',
                                    'Long Description': shangjia_about_contact_and_basic_info['_shangjia_goodsProperty'],
                                    'Short Description': shangjia_about_contact_and_basic_info['_shangjia_goodsProperty'],
                                    'Youtube Link':'',
                                    'Color Family': 'Not Specified',
                                    'Seller SKU': _shangjia_variants_skus[i]['subsku'],
                                    'Length(cm)':'10',
                                    'Width(cm)':'15',
                                    'Height(cm)':'20',
                                    'Weight(kg)':'0.3',
                                    'Out Of Stock Status':'In Stock',
                                    'Date Available': util_get_date(),
                                    'Price': _shangjia_variants_skus[i]['normalLinePriceStr'].replace('$',''),
                                    'Special Price': _shangjia_variants_skus[i]['normalPriceStr'].replace('$',''),
                                    'Start date of promotion':'2023/9/23 0:00:00',
                                    'End date of promotion':'2025/9/23 0:00:00',
                                    'Quantity': _shangjia_variants_skus[i]['stockQuantity'],
                                    'Workmanship':'',
                                    'Warranty Type':'No Warranty',
                                    'Warranty Value':'',
                                    'Warranty Description':'',
                                    'Variation Image': _shangjia_variants_skus[i]['img'],
                                    'Image 1': futu1,
                                    'Image 2': futu2,
                                    'Image 3': futu3,
                                    'Image 4': futu4,
                                    'Image 5': futu5,
                                    'Image 6': futu6,
                                    'Image 7': futu7,
                                    'Image 8': futu8,
                                    'Image 9': futu9,
                                    'Image 10': futu10,
                                    'Custom Variation 1 Name':specs_key1_name,
                                    'Custom Variation 1 Value':_shangjia_variants_skus[i]['specs_key1_value'],
                                    'Custom Variation 2 Name': specs_key2_name,
                                    'Custom Variation 2 Value':_shangjia_variants_skus[i]['specs_key2_value'],
                                    'Muslim Friendly':'1'
                                    //'is request': shangjia_about_contact_and_basic_info['_is_request'] == 2 ? '已完成':'未',
                                }
                                export_datas2.push(export_data_item);
                                //
                            }
                        }
                    }
                }
                //
                exportToExcel(export_datas2, 'KULA'+file_name, "Sheet1");
                //
            });
            //
            $('#message-info').html('');
            //
        });
        //
    });
}

extract_catalog_products_export_dingzhi();

function extract_catalog_products_clean(){
    $('#extract-catalog-products-clean').click(function (){
        //
        if(confirm("确认清空吗?")){
             var bg = chrome.extension.getBackgroundPage();
            bg.storage_clear();
        }
        //
    });
}

extract_catalog_products_clean();
//
function extract_catalog_products_pause(){
    $('#extract-catalog-products-pause').click(function (){
        util_check_is_maps_page();
        //
        var bg = chrome.extension.getBackgroundPage();
        bg.pause_switch(function (){
            bg.storage_get(function (callback_data) {
                if(callback_data['pause'] == 1){
                    $('#extract-catalog-products-pause').text('后台采集已暂停,可点击开启');
                }else{
                    $('#extract-catalog-products-pause').text('后台采集已开启,可点击暂停');
                }
            });
          //
        });
        //
    });
}
extract_catalog_products_pause();

//
function extract_catalog_products_pause_page(){
    $('#extract-catalog-products-pause-page').click(function (){
        util_check_is_maps_page();
        //
        var bg = chrome.extension.getBackgroundPage();
        bg.pause_page_switch(function (){
            bg.storage_get(function (callback_data) {
                if(callback_data['pause_page'] == 1){
                    $('#extract-catalog-products-pause-page').text('已关闭自动翻页采集,可点击开启');
                }else{
                    $('#extract-catalog-products-pause-page').text('已开启自动翻页采集,可点击暂停');
                }
            });
          //
        });
        //
    });
}
extract_catalog_products_pause_page();
//
//
function btn_pause_list_switch(){
    $('#btn-pause-list-switch').click(function (){
        util_check_is_maps_page();
        //
        var bg = chrome.extension.getBackgroundPage();
        bg.pause_list_switch(function (){
            bg.storage_get(function (callback_data) {
                if(callback_data['pause_list'] == 1){
                    $('#btn-pause-list-switch').text('已关闭列表采集,可点击开启');
                }else{
                    $('#btn-pause-list-switch').text('已开启列表采集,可点击暂停');
                }
            });
          //
        });
        //
    });
}
btn_pause_list_switch();
//
function data_process(){
    //$('#message-info').html('加载中...');
    var bg = chrome.extension.getBackgroundPage();
    //
    bg.get_data_process();
    //
    bg.data_process_get(function (callback_data) {
        //$('#message-info').html('');
        let data_process = callback_data['data_process'];
        let total_add_shangjia_num = 0;
        let has_caiji_geren_num = 0;
        let has_caiji_company_num = 0;
        if(typeof data_process !== 'undefined' ){
            total_add_shangjia_num = data_process['total_add_shangjia_num'];
            has_caiji_geren_num = data_process['has_caiji_geren_num'];
            has_caiji_company_num = data_process['has_caiji_company_num'];
            //
            $('#data_process').html("已添加<span>"+total_add_shangjia_num+"</span>个商品,已采集<span>"+has_caiji_geren_num+"</span>个");
            //
        }
        //
    });
}
data_process();

setInterval(data_process, 3000);
//
//
function custom_add_product_submit(){
    $('#custom-add-product-btn').click(function (){
        $('.custom-add-product-form-box').show();
    });
    $('#custom-add-product-form-btn-submit').click(function (){
        let custom_product_links_val  = $('form#custom-add-product-form #field-custom-product-links').val();
        custom_product_links_val = custom_product_links_val.trim();
        if(custom_product_links_val == ''){
             $('#message-info').html("<span style='color:red;'>商品详情页链接不能为空！</span>");
            return false;
        }
        //
        let custom_product_links_val_arr = custom_product_links_val.split(/[(\r\n)\r\n]+/);
        let error_links = [];
        for(let i=0;i<custom_product_links_val_arr.length;i++){
            let custom_product_link = custom_product_links_val_arr[i];
            custom_product_link = custom_product_link.trim();
            if(custom_product_link==''){
                continue;
            }else if(custom_product_link.indexOf('/itm/')==-1){
                error_links.push(custom_product_links_val_arr[i]);
            }
        }
        if(error_links.length>0){
            let error_links_str = '';
            for(let j=0;j<error_links.length;j++){
                error_links_str+=error_links[j]+'<br />';
            }
            $('#message-info').html("<p style='color:red;'>以下链接不正确，请修正或者删除后提交</p>"+error_links_str)
                .css({'max-height':'100px','overflow-y':'auto'});
            return false;
        }
        //
        let shangjia_infos = [];
        for(let i=0;i<custom_product_links_val_arr.length;i++){
            let _product_link = custom_product_links_val_arr[i];
            _product_link = _product_link.trim();
            if(_product_link.indexOf('?')!=-1){
                let _product_link_arr = _product_link.split('?');
                _product_link = _product_link_arr[0];
            }
            //
            let _shangjia_id = _product_link.replace('https://www.ebay.com/itm/','');
            let _shangjia_info = {
                   '_shangjia_id': _shangjia_id,
                   '_shangjia_name': '',
                   '_shangjia_a_link':_product_link,
                   '_shangjia_img': '',
                   '_shangjia_price': '',
                   '_shangjia_old_price': '',
                   '_shangjia_review_score': '',
                   '_shangjia_reivew_num': '',
                   '_shangjia_sold': ''
               };
            shangjia_infos.push(_shangjia_info);
            //
            if(shangjia_infos.length >= 50){
                var message = {
                    action: 'shangjia_items_update',
                    info: '',
                    shangjia_infos: shangjia_infos
                };
                send_message_to_background(message);
                shangjia_infos = [];
            }
            //
        }
        //
         var message = {
             action: 'shangjia_items_update',
             info: '',
             shangjia_infos: shangjia_infos
        };
        send_message_to_background(message);
        //
        window.alert('提交成功');
    });
}
custom_add_product_submit();
//
function dingzhi_name_btn_submit(){
    $('#dingzhi_name_btn_submit').click(function (){
        //util_check_is_maps_page();
        //
        let field_name = $('#field_name').val();
        field_name = field_name.trim();
        var bg = chrome.extension.getBackgroundPage();
        bg.field_name_set(field_name, function (){
            bg.storage_get(function (callback_data) {
               window.alert('保存成功');
            });
          //
        });
        //
    });
}
dingzhi_name_btn_submit();
//
//
function jihuo(){
    $('#jihuo_btn').click(function (){
        util_check_is_maps_page();
        var jihuo_text = $('#jihuo_text').val();
        jihuo_text = jihuo_text.trim();
        $('#message-info').html('');
        if(jihuo_text==''){
            $('#message-info').html('<span style="color:red;">请输入激活码</span>');
            return;
        }
        //
        // other then GET
        let options = {
            method: 'GET',
            headers: {
                'Content-Type':'application/json;charset=utf-8'
            },
            //body: JSON.stringify(res)
        }
        // Fake api for making post requests
        let fetchRes = fetch( "https://api.gycharm.com/v1/plugin-chkpro/" + jihuo_text);
        fetchRes.then(res =>
            res.json()).then(d => {
                console.log('post response:');
                console.log(d);
                console.log(d['VAL']);
                //
                if (d['VAL'] === "NO_KEY") {
                    $('#message-info').html('<span style="color:red;">激活码不存在!</span>');
                }else if(d['VAL'] == 'HAS_BOUND'){
                    $('#message-info').html('<span style="color:red;">激活码已使用过!</span>');
                }else {
                    var expire_date = d['VAL'];
                    if (util_check_expire(expire_date) == false) {
                        var bg = chrome.extension.getBackgroundPage();
                        bg.plugin_set_expire(expire_date,function (){
                            expire_date = expire_date.replace('T00:00:00.000Z','');
                            $('#expire_date').html(expire_date);
                            $('.jihuo').hide();
                            $('#message-account-info').html('');
                        });
                      //
                    }else{
                        $('.jihuo').show();
                        $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                        $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin?plugin=vip_ebay_1nian&type=other_plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                        return;
                    }
                }
                //
            })
                //
    });
}
jihuo();

//
function init(){
    var bg = chrome.extension.getBackgroundPage();
    bg.storage_get(function (callback_data) {
        if(callback_data.hasOwnProperty('pause') && callback_data['pause'] == 1){
            $('#extract-catalog-products-pause').text('后台采集已暂停,可点击开启');
        }else{
            $('#extract-catalog-products-pause').text('后台采集已开启,可点击暂停');
        }
        $('#extract-catalog-products-pause').show();
        //自动翻页采集
        if(callback_data.hasOwnProperty('pause_page') && callback_data['pause_page'] == 1){
            $('#extract-catalog-products-pause-page').text('已关闭自动翻页采集,可点击开启');
        }else{
            $('#extract-catalog-products-pause-page').text('已开启自动翻页采集,可点击暂停');
        }
        $('#extract-catalog-products-pause-page').hide();
        //
        //列表页采集
        if(callback_data.hasOwnProperty('pause_list') && callback_data['pause_list'] == 1){
            $('#btn-pause-list-switch').text('已关闭列表页采集,可点击开启');
        }else{
            $('#btn-pause-list-switch').text('已开启列表采集,可点击暂停');
        }
        //
        //文件名
        if(callback_data.hasOwnProperty('field_name')){
            $('#field_name').val(callback_data['field_name']);
        }
        //
    });
}
init();
//从content接收信息
chrome.runtime.onMessage.addListener((req, send, sendRes) => {
    console.log("收到info:", req.info)
    console.log("收到action:", req.action)
    console.log("收到tbm_map_urls:", req.maijia_num)

    if(req.action == 'update-shangjia-num'){
        var catalog_products_num = 0;
        var maijia_num = req.maijia_num;
        $('.catalog-products-num').html(maijia_num);
    }else if(req.action == 'background-tips'){
        //
        $('#message-info').html("<div style='color:red'>"+req.info+"</div>");
        //
         //
        //chrome.tabs.create({ url: req.url });
        //
    }

    //sendRes("popup已经收到")

  })
//

function send_message_to_background(message={}){
    console.log('message');
    console.log(message);
    chrome.runtime.sendMessage(message, function(response) {
      console.log("收到来自background.js的响应: " + response);
    });
}
//
document.getElementById("opnFacebook").addEventListener('click', function () {
  chrome.tabs.create({ url: "https://www.ebay.com" });
})
//
//get columns
function getColumns(paramData){

	var header = [];
	$.each(paramData[0], function (key, value) {
		//console.log(key + '==' + value);
		var obj = {}
		obj["headertext"] = key;
		obj["datatype"] = "string";
		obj["datafield"] = key;
		header.push(obj);
	});
	return header;
}
//
function exportToExcel(data, fileName, sheetName) {
  // Create a new workbook
  var wb = XLSX.utils.book_new();

  // Convert your data to an array of arrays (2D array)
  var wsData = XLSX.utils.json_to_sheet(data);

  // Add the worksheet to the workbook
  XLSX.utils.book_append_sheet(wb, wsData, sheetName);

  // Generate the Excel file and trigger a download
  XLSX.writeFile(wb, fileName + ".xlsx");
}

function exportToCsv(data, fileName, sheetName) {
  // Create a new workbook
  var wb = XLSX.utils.book_new();

  // Convert your data to an array of arrays (2D array)
  var wsData = XLSX.utils.json_to_sheet(data);

  // Add the worksheet to the workbook
  XLSX.utils.book_append_sheet(wb, wsData, sheetName);

  // Generate the Excel file and trigger a download
  XLSX.writeFile(wb, fileName + ".csv");
}

function extract_product_lunbo_imgs(){
    $('#extract-product-lunbo-imgs').click(function (){
        $('#message-info').html('处理中...')
        console.log('extract-product-lunbo-imgs');
        // popup ---> content
        chrome.tabs.query({
            active: true,
            currentWindow: true
        }, (tabs) => {
            let message = {
                action: 'extract-product-lunbo-imgs',
                info: ''
            }
            chrome.tabs.sendMessage(tabs[0].id, message, res => {
                console.log('popup=>content')
                console.log(res)
                //
            })
        })
        //
    });
}

extract_product_lunbo_imgs();

function extract_product_details_imgs(){
    $('#extract-product-details-imgs').click(function (){
        $('#message-info').html('处理中...')
        console.log('extract-product-details-imgs');
        // popup ---> content
        chrome.tabs.query({
            active: true,
            currentWindow: true
        }, (tabs) => {
            let message = {
                action: 'extract-product-details-imgs',
                info: ''
            }
            chrome.tabs.sendMessage(tabs[0].id, message, res => {
                console.log('popup=>content')
                console.log(res)
                //
            })
        })
        //
    });
}

extract_product_details_imgs();

function extract_products_lunbo_imgs(){
    $('#extract-products-lunbo-imgs').click(function (){
       if (window.confirm("确定要下载吗？下载时浏览器当前页面保持不动！")) {
           util_check_is_maps_page();
           var bg = chrome.extension.getBackgroundPage();
           bg.storage_get(function (callback_data) {
               let expire_date = callback_data['expire'];
               if (typeof expire_date === 'undefined') {
                   $('.jihuo').show();
                   $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                   $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin?plugin=vip_ebay_1nian&type=other_plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                   return;
               } else {
                   console.log('expire_date');
                   console.log(expire_date);
                   expire_date = expire_date.replace('T00:00:00.000Z', '');
                   $('#expire_date').html(expire_date);
                   if (util_check_expire(expire_date)) {
                       $('.jihuo').show();
                       $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                       $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin?plugin=vip_ebay_1nian&type=other_plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                       return;
                   }
               }
           });
           //
           chrome.storage.local.get(null, function(items) {
                let galleryimgs = [];
                //
                for (let key in items) {
                    if (key.indexOf('shangjia_about_contact_and_basic_info_') != -1) {
                        if (items[key]['_is_request'] == 2) {
                            let shangjia_about_contact_and_basic_info = items[key];
                            let _shangjia_gallery_arr = shangjia_about_contact_and_basic_info['_shangjia_gallery'];
                            for(let i=0;i<_shangjia_gallery_arr.length;i++){
                                let _img = _shangjia_gallery_arr[i];
                                let _img_src = _img;
                                let _imgarr = _img.split('/');
                                let _img_name = _imgarr[_imgarr.length-1];
                                let _img_name_arr = _img_name.split('.');
                                _img_name = _img_name_arr[0];
                                _img_name = shangjia_about_contact_and_basic_info['_shangjia_goodsId']+'_'+_img_name;
                                //
                                galleryimgs.push({
                                    'url':  _img_src,
                                    'name': _img_name
                                });
                            }
                        }
                    }
                }
                //
                // popup ---> content
                chrome.tabs.query({
                    active: true,
                    currentWindow: true
                }, (tabs) => {
                    let message = {
                        action: 'extract_products_lunbo_imgs',
                        info: '',
                        galleryimgs:galleryimgs
                    }
                    chrome.tabs.sendMessage(tabs[0].id, message, res => {
                        console.log('popup=>content')
                        console.log(res)
                        //
                    })
                })
                //
            });
           //
       }
    });
}
extract_products_lunbo_imgs();


function extract_products_detail_imgs(){
    $('#extract-products-details-imgs').click(function (){
       if (window.confirm("确定要下载吗？下载时浏览器当前页面保持不动！")) {
           util_check_is_maps_page();
           var bg = chrome.extension.getBackgroundPage();
           bg.storage_get(function (callback_data) {
               let expire_date = callback_data['expire'];
               if (typeof expire_date === 'undefined') {
                   $('.jihuo').show();
                   $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                   $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin?plugin=vip_ebay_1nian&type=other_plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                   return;
               } else {
                   console.log('expire_date');
                   console.log(expire_date);
                   expire_date = expire_date.replace('T00:00:00.000Z', '');
                   $('#expire_date').html(expire_date);
                   if (util_check_expire(expire_date)) {
                       $('.jihuo').show();
                       $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                       $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin?plugin=vip_ebay_1nian&type=other_plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                       return;
                   }
               }
           });
           //
           chrome.storage.local.get(null, function(items) {
                let detailsimgs = [];
                //
                for (let key in items) {
                    if (key.indexOf('shangjia_about_contact_and_basic_info_') != -1) {
                        if (items[key]['_is_request'] == 2) {
                            let shangjia_about_contact_and_basic_info = items[key];
                            let _shangjia_productDetailFlatList = shangjia_about_contact_and_basic_info['_shangjia_productDetailFlatList'];
                            for(let i=0;i<_shangjia_productDetailFlatList.length;i++){
                                let _img = _shangjia_productDetailFlatList[i];
                                let _img_src = _img;
                                let _imgarr = _img.split('/');
                                let _img_name = _imgarr[_imgarr.length-1];
                                let _img_name_arr = _img_name.split('.');
                                _img_name = _img_name_arr[0];
                                _img_name = shangjia_about_contact_and_basic_info['_shangjia_goodsId']+'_detail_'+_img_name;
                                //
                                detailsimgs.push({
                                    'url':  _img_src,
                                    'name': _img_name
                                });
                            }
                        }
                    }
                }
                //
                // popup ---> content
                chrome.tabs.query({
                    active: true,
                    currentWindow: true
                }, (tabs) => {
                    let message = {
                        action: 'extract_products_detail_imgs',
                        info: '',
                        detailsimgs:detailsimgs
                    }
                    chrome.tabs.sendMessage(tabs[0].id, message, res => {
                        console.log('popup=>content')
                        console.log(res)
                        //
                    })
                })
                //
            });
           //
       }
    });
}
extract_products_detail_imgs();